dnl Process this file with "m4 -DLANG=C" or "m4 -DLANG=PERL" to generate an
dnl API document.
dnl
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2//EN">

<!-- This file was generated from libcoral.m4. -->

<!--
  Copyright 1999, 2000, 2001 The Regents of the University of California 
  All Rights Reserved 
  
  Permission to use, copy, modify and distribute any part of this
  CoralReef software package for educational, research and non-profit
  purposes, without fee, and without a written agreement is hereby
  granted, provided that the above copyright notice, this paragraph
  and the following paragraphs appear in all copies.
  
  Those desiring to incorporate this into commercial products or use
  for commercial purposes should contact the Technology Transfer
  Office, University of California, San Diego, 9500 Gilman Drive, La
  Jolla, CA 92093-0910, Ph: (858) 534-5815, FAX: (858) 534-7345.
  
  IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY
  PARTY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL
  DAMAGES, INCLUDING LOST PROFITS, ARISING OUT OF THE USE OF THIS
  SOFTWARE, EVEN IF THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF
  THE POSSIBILITY OF SUCH DAMAGE.
  
  THE SOFTWARE PROVIDED HEREIN IS ON AN "AS IS" BASIS, AND THE
  UNIVERSITY OF CALIFORNIA HAS NO OBLIGATION TO PROVIDE MAINTENANCE,
  SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS. THE UNIVERSITY
  OF CALIFORNIA MAKES NO REPRESENTATIONS AND EXTENDS NO WARRANTIES
  OF ANY KIND, EITHER IMPLIED OR EXPRESS, INCLUDING, BUT NOT LIMITED
  TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
  PARTICULAR PURPOSE, OR THAT THE USE OF THE SOFTWARE WILL NOT INFRINGE
  ANY PATENT, TRADEMARK OR OTHER RIGHTS.
  
  The CoralReef software package is developed by the CoralReef
  development team at the University of California, San Diego under
  the Cooperative Association for Internet Data Analysis (CAIDA)
  Program. Support for this effort is provided by the CAIDA grant
  NCR-9711092, DARPA NGI Contract N66001-98-2-8922, DARPA NMS Grant
  N66001-01-1-8909, and by CAIDA members.
  
  Report bugs and suggestions to coral-bugs@caida.org.
-->

dnl
dnl Verify LANG.
define(usage,
    `changequote([,])errprint([LANG] must be defined as C or PERL.)m4exit()')dnl
ifdef(`LANG', , `usage')dnl
ifelse(LANG, C, , LANG, PERL, , `usage')dnl
undefine(`usage')dnl
dnl
changequote(,)dnl
changecom(@)dnl
dnl
dnl The basic language choice macros.
define(DOC_C, ifelse(LANG, C, $1))dnl
define(DOC_PERL, ifelse(LANG, PERL, $1))dnl
define(DOC_BOTH, ifelse(LANG, C, $1, LANG, PERL, $2))dnl
dnl
dnl Abbreviated HTML macros
define(CODE, <code>$1</code>)dnl
define(VAR, <var>$1</var>)dnl
dnl
dnl Convenience macros for frequently occuring text.
define(DOC_LANG, DOC_BOTH(C, Perl))dnl
define(DOC_name, DOC_BOTH(libcoral, CRL.pm))dnl
define(DOC_Name, DOC_BOTH(Libcoral, CRL.pm))dnl
define(DOC_NULL, CODE(DOC_BOTH(NULL, undef)))dnl
define(DOC_errno, DOC_BOTH(errno, $!))dnl
define(DOC_CORAL, DOC_BOTH(CORAL_$1, $1))dnl		constant
define(DOC_uint64, DOC_BOTH(uint64_t, NUM))dnl
define(DOC_COM, DOC_BOTH(/* $1 */, # $1))dnl		one-line comment
dnl DOC_REF(text, url)
dnl text is a reference to url
define(DOC_REF, <a href="$2">$1</a>)dnl
dnl DOC_OPT(name)
dnl name is a coral option
define(DOC_OPT, DOC_REF(CODE(DOC_CORAL(OPT_$1)), #DOC_CORAL(OPT_$1)))dnl
dnl DOC_CMD_USAGE(text [, #ref])
dnl text is a ref to cmd_usage.html#ref
define(DOC_CMD_USAGE, DOC_REF($1, cmd_usage.html$2))dnl
dnl DOC_APP(name)
dnl name is a coral application
define(DOC_APP, CODE(DOC_REF($1, applications.html#$1)))dnl
dnl DOC_ID(name)
dnl name is a coral function/identifier
define(DOC_ID, DOC_BOTH(coral_$1, $1))dnl
dnl DOC_IDREF(name)
dnl name is a ref to a coral function/identifier
define(DOC_IDREF, DOC_REF(DOC_ID($1), #DOC_ID($1)))dnl
dnl DOC_TYPE(type)
dnl "type" is the base of a coral type name
define(DOC_TYPE, DOC_BOTH(downcase(coral_$1_t), $1))dnl
dnl DOC_TYPEREF(type)
dnl a ref to a coral type
define(DOC_TYPEREF, DOC_REF(DOC_TYPE($1), #DOC_TYPE($1)))dnl
dnl DOC_PROTO(name)
dnl name is a coral protocol id
define(DOC_PROTO, DOC_CMD_USAGE(CODE(DOC_CORAL($1)), #protocols))dnl
dnl DOC_PROTOTYPE(c_prototype, perl_prototype)
dnl format a function prototype
define(DOC_PROTOTYPE, <pre>DOC_BOTH($1,$2)</pre>)dnl
dnl
dnl utilities
define(downcase, translit($1, ABCDEFGHIJKLMNOPQRSTUVWXYZ, abcdefghijklmnopqrstuvwxyz))dnl
dnl
dnl Get rid of m4 builtins that might conflict with our text.
undefine(decr)dnl
undefine(define)dnl
undefine(defn)dnl
undefine(divert)dnl
undefine(eval)dnl
undefine(expr)dnl
undefine(ifdef)dnl
undefine(ifelse)dnl
undefine(include)dnl
undefine(incr)dnl
undefine(index)dnl
undefine(len)dnl
undefine(maketemp)dnl
undefine(paste)dnl
undefine(shift)dnl
undefine(substr)dnl
undefine(unix)dnl
dnl
undefine(undefine)dnl
dnl
dnl
<HTML>
<HEAD>
  <title>Documentation for the DOC_LANG Coral API</title>
</HEAD>

<body>
<h1>DOC_name - a DOC_LANG API for CoralReef</h1>

<ul>
<li>DOC_REF(Introduction, #intro)
    <ul>
    DOC_C(<li>DOC_REF(Compiling, #compiling))
    DOC_PERL(<li>DOC_REF(Note on 'types', #legend))
    </ul>
<li>DOC_REF(The API, #api)
    <ul>
    DOC_PERL(
    <li>DOC_REF(Quick Start, #quick_start)
    )
    <li>DOC_REF(Command-line Configuration, #user-config)
	DOC_C(
	<ul>
	<li>DOC_REF(Examples, #user-config-ex)
	</ul>
	)
    <li>DOC_REF(Global Configuration, #prog-config)
    <li>DOC_REF(Source Configuration, #source)
    <li>DOC_REF(Opening, #opening)
    <li>DOC_REF(Packet Reading, #packet)
	DOC_C(
	<ul>
	<li>DOC_REF(Single packet reading, #single packet)
	<li>DOC_REF(Callback loop packet reading, #callback packet)
	<li>DOC_REF(Other packet reading features, #other packet)
	<li>DOC_REF(Pcap Packet Filtering, #pcap filtering)
	<li>DOC_REF(Packet reading example, #packet-ex)
	</ul>
	)
    <li>DOC_REF(DOC_BOTH(Cell/Block, Cell) Reading, #cell)
	DOC_C(
	<ul>
	<li>DOC_REF(General Description, #cell-general)
	<li>DOC_REF(Return values, #cell-return)
	<li>DOC_REF(Reading Functions, #cell-read)
	<li>DOC_REF(Related Functions, #cell-other)
	</ul>
	)
    <li>DOC_REF(Information, #info)
    <li>DOC_REF(Trace Writing, #DOC_ID(write))
	DOC_C(
	<ul>
	<li>DOC_REF(Example, #coral_write-ex)
	</ul>
	)
    DOC_C(
    <li>DOC_REF(Pcap Conversion, #pcap)
	<ul>
	<li>DOC_REF(Example, #pcap-ex)
	</ul>
    )
    <li>DOC_REF(Other, #other)
    <li>DOC_BOTH(DOC_REF(Types, #types), DOC_REF(Classes, #classes))
    </ul>
</ul>

<a name="intro">
<h2>Introduction</h2></a>
DOC_Name provides a DOC_LANG API for reading network interface devices
and several different trace
file formats, and for writing trace files.
DOC_C(Some realistic examples of its use can be found in
    apps/utils/*.c in the distribution.)
DOC_PERL(
    It is mostly a wrapper for calls to
    DOC_REF(libcoral, libcoral-c.html),
    with some additional Perl-centric structures when
    appropriate.
)
<p>
Libcoral operates on "sources", which include several types of
live network interfaces/devices, and several types of tracefiles containing
data recorded from one or more network interfaces/devices.
The naming scheme for sources is described in the
DOC_CMD_USAGE(command usage document, #sourcenames).
<p>
A typical program using DOC_name has this basic structure:
<pre>
  DOC_REF(configure, #DOC_ID(config)) DOC_name and one or more sources
  DOC_REF(open, #DOC_ID(open)) sources
  DOC_REF(start, #DOC_ID(start)) sources
  while (read DOC_C(block, )cell or packet != DOC_NULL) {
      process the data we just read
      if (stop condition occurs) {
	  DOC_REF(stop, #DOC_ID(stop)) sources
      }
  }
  DOC_REF(close, #DOC_ID(close)) sources
</pre>
<p>
DOC_PERL(All identifiers defined in this document are in the CODE(Coral)
namespace.<p>)
In the descriptions below, there are several pairs of functions with the same
base name, with or without an "_all" suffix.
The function suffixed with "_all" operates on
all sources, and the other one operates on a single source indicated by
the VAR(src) parameter.

DOC_C(
<a name="compiling">
<h3>Compiling</h3></a>
<p>
All CoralReef programs should include these headers:
<pre>
#include &lt;stdio.h&gt;
#include &lt;sys/param.h&gt;
#include &lt;libcoral.h&gt;
</pre>
Note that CODE(&lt;libcoral.h&gt;) will define fixed-width integer types
(like CODE(uint32_t)) if your system does not, since they are needed
by many libcoral structures.

<p>
CoralReef programs should link with CODE(-lcoral),
CODE(-lpcap) (if libcoral was compiled with pcap support), and
CODE(-lz) (if libcoral was compiled with zlib support).
)

DOC_PERL(
<a name="legend">
<h3>Note on 'types'</h3>
The 'types' listed in the class definitions and function parameters
vary somewhat from standard Perl form.  When possible, instead of
merely calling them 'SCALAR' or 'LIST', additional information has been
given as to the type of the parameter.  Optional parameters are followed
by "=" and their default value.  Examples of types:
<dl>
    <dt>BOOL
	<dd>A Boolean (true/false) value.  Usually 0 or 1.
    <dt>STR
	<dd>A string value.
    <dt>NUM
	<dd>A number (integer or floating point) value.
    <dt>LIST REF
	<dd>A reference to a list.
    <dt>STR REF
	<dd>A reference to a string.
    <dt>VAR(class)_REF
	<dd>A blessed reference to one of the
	DOC_REF(classes, #classes) used by Coral.
    <dt>SCALAR
	<dd>An opaque object, never accessed directly by the user.
	Usually returned by a function call.  For example, the
	timestamp in the DOC_TYPEREF(Cell) or
	DOC_TYPEREF(Pkt_buffer) classes, which is read by
	the DOC_IDREF(read_clock) functions, or
	a source or interface returned by the
	DOC_IDREF(next_source) or
	DOC_IDREF(next_interface) functions.
</dl>
Also, the 'FILEHANDLE' types must be attached to an actual stdio FILE.
)

<a name="api">
<h2>The API</h2></a>

DOC_PERL(
<h3>Quick Start</h3></a>
<DL>
<A NAME="DOC_ID(quick_start)">
<DT>
<PRE>
<b>quick_start</b>(BOOL time_sort = 1, BOOL partial_pkt = 1, NUM api = DOC_CORAL(API_PKT));
</PRE>
<DD>This Perl-only function does the configuration and startup for
most common cases of CRL use.  If finer control is needed, use the 
DOC_REF(command line configuration, #user-config) and
DOC_REF(global configuration, #prog-config)
functions below.
If VAR(time_sort) equals 0, cells will not be sorted, otherwise they will.
If VAR(partial_pkt) equals 0, then truncated packets are discarded by
DOC_IDREF(read_pkt)(), otherwise they are accepted.
VAR(Api) allows the user to set the libcoral API being used; the default is
DOC_CORAL(API_PKT).
<P>
To limit the number of sources that will be allowed, call
CODE(DOC_IDREF(set_max_sources)())
before calling this function.
<p>
This function returns nothing.
If any fatal errors are encountered, it exits.
<p>
The code consists of:

<PRE>
sub quick_start {
    my ($time_sort, $partial_pkt, $api) = @_;

    if (defined $time_sort and $time_sort == 0) {
	if (DOC_IDREF(set_options)($DOC_OPT(SORT_TIME), 0) &lt; 0) {
	    DOC_IDREF(puts)("Warning: could not unset time-sorting option!");
	}
    } elsif (DOC_IDREF(set_options)(0, $DOC_OPT(SORT_TIME)) &lt; 0) {
	DOC_IDREF(puts)("Warning: could not set time-sorting option!");
    }

    if (defined $partial_pkt and $partial_pkt == 0) {
	if (DOC_IDREF(set_options)($DOC_OPT(PARTIAL_PKT), 0) &lt; 0) {
	    DOC_IDREF(puts)("Warning: could not unset partial packeting option!");
	}
    } elsif (DOC_IDREF(set_options)(0, $DOC_OPT(PARTIAL_PKT)) &lt; 0) {
	DOC_IDREF(puts)("Warning: could not set partial packeting option!");
    }

    if (defined $api) {
	if (DOC_IDREF(set_api)($api) &lt; 0) {
	    DOC_IDREF(puts)("Warning: could not specify api!");
	}
    } elsif (DOC_IDREF(set_api)($DOC_ID(API_PKT)) &lt; 0) {
	DOC_IDREF(puts)("Warning: could not specify packet api!");
    }

    if (DOC_IDREF(config_arguments)(scalar(@ARGV), \@ARGV) &lt; 0) {
	DOC_IDREF(puts)("Error: could not parse command-line options!");
	exit(1);
    }
    if (DOC_IDREF(open_all)() &lt;= 0) { # no openable sources is considered an error
	DOC_IDREF(puts)("Error: could not open any sources!");
	exit(1);
    }
    if (DOC_IDREF(start_all)() &lt; 0) {
	DOC_IDREF(puts)("Error: could not start any sources!");
	exit(1);
    }
}
</PRE>
<dt>
</dl>
)

<a name="DOC_ID(config)">
<a name="user-config"><h3>Command-line Configuration</h3></a>
The following functions read coral commands from the command line or
config files.  The coral commands are described in the
DOC_CMD_USAGE(command usage document).
These functions should only be called before
DOC_IDREF(open)() or
DOC_IDREF(open_all)().
<p>
You should call DOC_IDREF(set_api)()
before calling these functions to enable certain configuration commands.
Also, you should set the defaults for configurable values with the
DOC_IDREF(set) functions before calling any of these
functions, and (if needed) get the value after.
This way, the option and its default value will appear in the
CODE(DOC_IDREF(usage)()) message, and the user can override the
defaults with command line options.  If your application does not use a
particular configurable value, you should leave it set to its initial value,
so it will not appear in the CODE(DOC_IDREF(usage)()) message,
and the DOC_IDREF(config) functions will not allow it
to be changed on the command line.

<dl>

<a name="DOC_ID(config_arguments)"></a>
<dt>
DOC_PROTOTYPE(
int <b>coral_config_arguments</b>(int argc, char *argv[]);,
<b>config_arguments</b>(NUM argc, LIST REF argv);)
</dt>
<dd>
This function processes "CODE(-C)" options and sourcename arguments
contained in VAR(argv).
VAR(Argv) is a DOC_BOTH(pointer to an array, reference to a list)
of strings containing the command line;
VAR(argc) is the number of strings in VAR(argv).
For a description of Coral options, see the
DOC_CMD_USAGE(Command Usage documentation).
A CoralReef source is created (with CODE(DOC_IDREF(new_source)()))
from each sourcename argument.
If an option syntax error is encountered, this function prints a usage message.
If other arguments are desired, use
CODE(DOC_IDREF(config_options)()) instead
and parse the arguments yourself;
if other options are desired, parse the options and arguments yourself and call 
CODE(DOC_IDREF(config_command)())
for each "CODE(-C)" option.
Returns a non-negative integer for success, -1 for failure.
<p>
To limit the number of sources that will be allowed, call
CODE(DOC_IDREF(set_max_sources)())
before calling this function.
<p>
DOC_BOTH(
For an example, see the DOC_REF(end of this section, #user-config-ex2).,
Sample call: CODE($nxt_idx = DOC_IDREF(config_options)(scalar(@ARGV),
\@ARGV, "&lt;outputfile&gt;");)
)

<a name="DOC_ID(config_options)"></a>
<dt>
DOC_PROTOTYPE(
int <b>coral_config_options</b>(int argc, char *argv[], const char *argmsg);,
<b>config_options</b>(NUM argc, LIST REF argv, STR argmsg);)
</dt>
<dd>
This function is like CODE(DOC_IDREF(config_arguments)()), except it
processes only the options, not the non-option arguments.
If VAR(argmsg) is DOC_NULL, this
function assumes that arguments (other than Coral options) are not allowed,
and considers it an error if other arguments are found;
otherwise, other arguments (but not other options) are allowed.
If successful, this function returns the index of the first non-option
argumentDOC_C( (so it would return 1 if there were no options,
since CODE(argv[0]) is the application name)).
It is the programmer's resposibility to handle
the remaining command line arguments.
If an error is encountered, this function returns -1, and prints a usage message
with CODE(DOC_IDREF(usage)DOC_BOTH(
    (argv[0], "%s", VAR(argmsg)),
    ($0, VAR(argmsg)))).
If other options are desired, use CODE(DOC_IDREF(config_command)()) instead.
Returns a non-negative integer for success, -1 for failure.
DOC_PERL(
    <p>
    Sample call: CODE($nxt_idx = DOC_IDREF(config_options)(scalar(@ARGV),
    \@ARGV, "&lt;outputfile&gt;");)
)dnl

<a name="DOC_ID(config_command)"></a>
<dt>
DOC_PROTOTYPE(
int <b>coral_config_command</b>(const char *command);,
<b>config_command</b>(STR command, STR filename, NUM linenum);
)
</dt>
<dd>
Processes a config command.  This function should be used instead of
CODE(DOC_IDREF(config_options)()) or CODE(DOC_IDREF(config_arguments)())
if you need to accept your own options in addition to CoralReef options,
or you want to accept CoralReef commands from inputs other than the command line.
DOC_PERL(
VAR(Filename) and VAR(linenum) are printed in error
messages; pass undef and 0 to have them not printed.
)dnl
Returns 0 for success, -1 for failure.

<a name="DOC_ID(config_file)"></a>
<dt>
DOC_PROTOTYPE(
int <b>coral_config_file</b>(const char *filename);,
<b>config_file</b>(STR filename);
)
</dt>
<dd>
Process CoralReef commands in file VAR(filename).
This is not usually needed if CODE(DOC_IDREF(config_arguments)()),
CODE(DOC_IDREF(config_options)()), or CODE(DOC_IDREF(config_command)())
is used.

<a name="DOC_ID(usage)"></a>
<dt>
DOC_PROTOTYPE(
int <b>coral_usage</b>(const char *appname, const char *argmsg, ...);,
<b>usage</b>(STR appname, STR argmsg = undef);
)
</dt>
<dd>
Prints a message describing the command line syntax of a CoralReef application
named VAR(appname).
DOC_BOTH(
If VAR(argmsg) is not DOC_NULL,
it use used as a printf-style format for the arguments that follow,
and the formatted result is appended to the syntax line.,
If VAR(argmsg) is not undef, it is appended to the syntax line.
)
This is followed by descriptions of the CoralReef (-C) command line options.
<p>
Some example values for VAR(argmsg):
    <dl>
    <dt>for an application that takes CoralReef options and no arguments:
	<dd>DOC_NULL
    <dt>for an application that takes CoralReef options and an optional argument
	<dd>CODE("[&lt;argument&gt;]")
    <dt>for an application that takes -f, -b<var>N</var>, and CoralReef options,
    and one or more VAR(source) arguments:
	<dd>CODE("[-f] [-b&lt;N&gt;] &lt;source&gt;...")
    </dl>

</dl>

<a name="user-config-ex">
<h4>Examples</h4></a>
DOC_C(
All these examples assume you will be using the
DOC_REF(packet API, #packet); you should change the argument of
DOC_IDREF(set_api)() as needed.
<p>
<a name="user-config-ex1">
If only CoralReef options and sourcename arguments are needed,
this simple code will do:
<pre>
    DOC_IDREF(set_api)(DOC_CORAL(API_PKT));
    if (DOC_IDREF(config_arguments)(argc, argv) &lt; 0)
        exit(-1);
</pre>

<a name="user-config-ex2">
If other options are desired, you must parse the options and arguments yourself,
like this:
<pre>
    int opt, foo_flag = 0, bar = 42;
    extern char *optarg;
    extern int optind;

    DOC_IDREF(set_api)(DOC_CORAL(API_PKT));

    while ((opt = getopt(argc, argv, "C:fb:")) != -1) {
        switch (opt) {
        case 'C':
            if (DOC_IDREF(config_command)(optarg) &lt; 0)
                exit(-1);
            break;
        case 'f':
            foo_flag = 1;
            break;
        case 'b':
            bar = atoi(optarg);
            break;
        default:
            DOC_IDREF(usage)(argv[0], "[-f] [-b&lt;N&gt;] &lt;source&gt;\n"
		"-f      foo flag\n"
		"-b&lt;n&gt;   bar value (default %d)\n",
		bar);
            exit(-1);
        }
    }

    while (optind &lt; argc) {
        if (!DOC_IDREF(new_source)(argv[optind]))
            exit(-1);
        optind++;
    }
</pre>
If a bad option is given, this code will print a message like this to stderr,
followed by descriptions of the CoralReef commands that are allowed for the
configured API:
<pre>
    CODE(Usage: VAR(app) [-C &lt;coral_command&gt;]... [-f] [-b&lt;N&gt;] &lt;source&gt;...)
</pre>
)dnl
DOC_PERL(
    If only Coral options and filename arguments are needed,
    this simple code will do:
    <pre>
	DOC_IDREF(quick_start)(0); # or 1 for time-sorting
    </pre>
    followed by the read_cell routines.

    If other options are desired, you must parse the options
    and arguments yourself.

    If a bad option is given, this code will print a message
    like this to stderr, followed by descriptions of the Coral
    commands:
    <pre>
      CODE(Usage: VAR(app) [-C &lt;command&gt;]... &lt;source&gt;)
    </pre>
)dnl

<a name="DOC_ID(set)">
<a name="DOC_ID(get)">
<a name="prog-config"><h3>Global Configuration</h3></a>
The following functions provide a way for the programmer to set global
configuration values, including default values for the configuration of
sources that have not yet been defined.
The CODE(DOC_IDREF(set)) functions can be called
before the CODE(DOC_IDREF(config)) functions to set default
values that can be overridden on the command line or config file, and will
be displayed in the CODE(DOC_IDREF(usage)) message.
If the integer configuration values are set to a negative value,
they will not be displayed in the CODE(DOC_IDREF(usage)) message.
The CODE(DOC_IDREF(set)) functions can also be called
after the CODE(DOC_IDREF(config)) functions
so their values can't be overridden.
They must not be called after sources are opened.
The CODE(DOC_IDREF(set)) functions return 0 if successful, or -1 for failure;
the CODE(DOC_IDREF(get)) functions return the value of the requested datum.
<p>

<dl>

<a name="DOC_ID(set_api)"></a>
<dt>
DOC_PROTOTYPE(
int <b>coral_set_api</b>(int api);,
<b>set_api</b>(NUM api);
)
<dd>
The VAR(api) parameter to CODE(DOC_IDREF(set_api)()) must be
DOC_C(CODE(DOC_REF(DOC_CORAL(API_BLOCK), #coral_read_block)),
)dnl
CODE(DOC_REF(DOC_CORAL(API_CELL), #cell)), or
CODE(DOC_REF(DOC_CORAL(API_PKT), #packet)),
optionally bitwise ORed with
CODE(DOC_REF(DOC_CORAL(API_WRITE), #DOC_ID(write))).
It initializes libcoral for use with the corresponding APIs,
and should be called before any coral config, reading, or writing function.
<p>
Setting the APIs enables command line and configuration file options
and functions that are specific to those APIs.  DOC_Name will generate
an error if any disallowed option or function is attempted.
<p>
The VAR(api) parameter should contain exactly one of the following
constants:
<table border=1>
<tr><td>API
    <td>allowed DOC_CMD_USAGE(configuration commands, #config_commands)
    <td>allowed functions
<tr>
DOC_C(
<tr><td>CODE(DOC_REF(DOC_CORAL(API_BLOCK), #coral_read_block))
    <td>
    CODE(blocks)
    <td>
)dnl
<tr><td>CODE(DOC_REF(DOC_CORAL(API_CELL), #cell))
    <td>
    CODE(cells)
    CODE(blocks)
    CODE(deny)
    <td>
<tr><td>CODE(DOC_REF(DOC_CORAL(API_PKT), #packet))
    <td>
    CODE(packets)
    CODE(filter)
    CODE(deny)
    <td>
    DOC_IDREF(add_pcap_filter)()
</table>
Commands and functions not listed under any API are valid for all APIs.
<p>
The VAR(api) parameter may optionally be bitwise-ORed with this
constant, if DOC_IDREF(write) will be used:
<table border=1>
<tr><td>API
    <td>allowed DOC_CMD_USAGE(configuration commands, #config_commands)
    <td>allowed functions
<tr>
<tr><td>CODE(DOC_REF(DOC_CORAL(API_WRITE), #DOC_ID(write)))
    <td>
    CODE(gzip)
    <td>
    CODE(DOC_IDREF(set_gzip)())
</table>
<p>
Example:  CODE(DOC_ID(set_api)(DOC_CORAL(API_PKT) | DOC_CORAL(API_WRITE));)

<a name="DOC_ID(set_max_sources)"></a>
<a name="DOC_ID(get_max_sources)"></a>
<dt>
DOC_PROTOTYPE(
int <b>coral_set_max_sources</b>(int n);
int <b>coral_get_max_sources</b>(void);,
<b>set_max_sources</b>(NUM n);
<b>get_max_sources</b>();
)
<dd>
CODE(DOC_IDREF(set_max_sources)()) sets the maximum number of allowed Coral
sources to VAR(n).  It should be called before
CODE(DOC_IDREF(config_arguments)()),
CODE(DOC_IDREF(config_options)()),
CODE(DOC_IDREF(config_command)()), and
CODE(DOC_IDREF(new_source)())
to restrict them.
It returns 0 if successful,
or -1 if VAR(n) is negative or greater than 16.
CODE(DOC_IDREF(get_max_sources)()) returns the maximum number of allowed Coral
sources.
The default max_sources value is 16.

<a name="DOC_ID(set_options)"></a>
<a name="DOC_ID(get_options)"></a>
<dt>
DOC_PROTOTYPE(
int <b>coral_set_options</b>(int off, int on);
int <b>coral_get_options</b>(void);,
<b>set_options</b>(NUM off, NUM on);
<b>get_options</b>();
)
<dd>
CODE(DOC_IDREF(set_options)()) disables the options in the bitmask
VAR(off) and enables the options in the bitmask VAR(on).
CODE(DOC_IDREF(get_options)()) returns a bitmask of currently enabled options.
The options are:
<dl>
<a name="DOC_CORAL(OPT_SORT_TIME)"></a>
<dt>CODE(DOC_CORAL(OPT_SORT_TIME)) DOC_BOTH(
    (default: off),
    (default: off, unless DOC_IDREF(quick_start)()</a> is used.))
    <dd>Makes CODE(DOC_IDREF(read_cell_all)()) read cells in timestamp order.
    For this option to make sense, one of the following must be true:
    all interfaces have start epochs and were started at the same time, or
    all interfaces have unix epochs, or
    the DOC_OPT(NORMALIZE_TIME)
    option is on.
    If none of these conditions is true, libcoral will automatically enable the
    DOC_OPT(NORMALIZE_TIME)
    option.
<a name="DOC_CORAL(OPT_PARTIAL_PKT)"></a>
<dt>CODE(DOC_CORAL(OPT_PARTIAL_PKT)) (default: on)
    <dd>Allows CODE(DOC_IDREF(read_pkt)())
    DOC_C(and CODE(DOC_IDREF(read_pkts)()))
    to handle partial packets.
<a name="DOC_CORAL(OPT_FATM_RAW_TIME)"></a>
<dt>CODE(DOC_CORAL(OPT_FATM_RAW_TIME)) (default: off)
    <dd>Do not attempt to automatically correct the delayed firmware clock
    increment when the hardware clock wraps in the fatm card
    or skip cells prior to a clock reset in the first block.
    This can be used to improve performance
    if cell/packet timestamps will not be needed.
<a name="DOC_CORAL(OPT_POINT_RAW_TIME)"></a>
<dt>CODE(DOC_CORAL(OPT_POINT_RAW_TIME)) (default: off)
    <dd>Do not attempt to automatically skip cells prior to a clock reset
    in the first block.
    This can be used to improve performance
    if cell/packet timestamps will not be needed.
<a name="DOC_CORAL(OPT_RAW_TIME)"></a>
<dt>CODE(DOC_CORAL(OPT_RAW_TIME))
    <dd>Equivalent to
    CODE((DOC_OPT(FATM_RAW_TIME) | DOC_OPT(POINT_RAW_TIME))).
<a name="DOC_CORAL(OPT_NORMALIZE_TIME)"></a>
<dt>CODE(DOC_CORAL(OPT_NORMALIZE_TIME)) (default: on)
    <dd>Make the result of the DOC_IDREF(read_clock)
    relative to the unix epoch (1970-01-01 00:00:00 UTC);
    otherwise, the result will have some interface-dependant epoch.
    Normalizing is necessary when comparing times from multiple interfaces
    (this includes using DOC_OPT(SORT_TIME))
    with different default epochs.
    But normalizing may introduce inaccuracy if
    the interfaces' hosts' CPU clocks are inaccurate,
    and may introduce additional processing overhead.
    The default epochs for the various types of interfaces are:
    <dl compact>
    <dt>DOC_CMD_USAGE(fatm, #fatm)
	<dd>time of reset (e.g., by CODE(DOC_IDREF(start_all))());
    <dt>DOC_CMD_USAGE(point, #point)
	<dd>time of reset (e.g., by CODE(DOC_IDREF(start_all))());
    <dt>DOC_CMD_USAGE(dag, #dag)
	<dd>the unix epoch (of the CPU used to do the capture)
    <dt>DOC_CMD_USAGE(pcap, #pcaplive)
	<dd>the unix epoch (of the CPU used to do the capture)
    <dt>DOC_CMD_USAGE(tsh, #tsh)
	<dd>either the unix epoch or the time of reset, depending
	on the original source of data (libcoral can identify the
	epoch automatically)
    </dl>
    Traces from interfaces that don't natively use the unix epoch can only
    be normalized if the capture time was recorded in the trace.
    DOC_CMD_USAGE(NLANR and MCI .crl traces, #nlanr)
    do not contain capture time, although
    their filenames sometimes do, and CoralReef can use that;
    DOC_CMD_USAGE(.crl traces, #crl) made with CoralReef prior to 3.2.1
    contain capture time only to the nearest second.
    Traces in DOC_CMD_USAGE(.tsh format, #tsh)
    do not explicitly contain the capture time,
    but if the data timestamps are relative to the unix epoch, libcoral
    will use the first timestamp as the capture time; otherwise, libcoral
    will infer a capture time from the filename if possible.
<a name="DOC_CORAL(OPT_NO_FILTER)"></a>
<dt>CODE(DOC_CORAL(OPT_NO_FILTER)) (default: off)
    <dd>Do not allow a pcap filter to be set by the
    DOC_IDREF(config) functions.  This is useful
    for applications that need to define their own filters.
<a name="DOC_CORAL(OPT_IP_CKSUM)"></a>
<dt>CODE(DOC_CORAL(OPT_IP_CKSUM)) (default: off)
    <dd>Tells CODE(DOC_IDREF(fmt_get_payload)())
    to print and verify IP checksums.
</dl>

<a name="DOC_ID(set_iomode)"></a>
<dt>
DOC_PROTOTYPE(
int <b>coral_set_iomode</b>(int off, int on, int first, int fixed);,
<b>set_iomode</b>(NUM off, NUM on, NUM first = -1, BOOL fixed = 0);
)
<dd>
This function sets the default I/O mode of all subsequently defined sources.
(To set the I/O mode of sources that have already been defined, use
CODE(DOC_IDREF(source_set_iomode)()).)
<p>
The arguments to this function are:
    <dl>
    <dt>VAR(off)
        <dd>bitmask of I/O mode flags to disable.
    <dt>VAR(on)
        <dd>bitmask of I/O mode flags to enable.
    <dt>VAR(first)DOC_PERL( (defaults to -1))
        <dd>specifies how many bytes to
	capture from each PDU (layer 2 packet/frame).
        If this parameter is negative, the configured value will be unchanged.
	For ATM interfaces, VAR(first) will be rounded up to a multiple
	of ATM cell payload size (48 bytes).
	(In versions prior to 3.2, VAR(first) was interpreted as cells
	instead of bytes on ATM interfaces.)
    <dt>VAR(fixed)DOC_PERL( (defaults to false))
	<dd>flag that prevents user from modifying the iomode via the command
	line or config file (this should be used before the
	CODE(DOC_IDREF(config)) functions, in applications
	with a non-configurable iomode).
    </dl>
<p>

The I/O mode flags:
    <table border=1>
    <tr><td>flag
	<td>equivalent DOC_CMD_USAGE(CLI iomode, #iomode)
	<td>description
    <tr>
    <tr><td>DOC_CORAL(TX)
	<td>DOC_CMD_USAGE(tx, #tx)
    	<td>allow transmitting (not implemented)
    <tr><td>DOC_CORAL(RX)
	<td>DOC_CMD_USAGE(rx, #rx)
    	<td>allow receiving
    <tr><td>DOC_CORAL(RX_IDLE)
	<td>DOC_CMD_USAGE(idle, #idle)
	<td>read all cells, including ATM idle cells
    <tr><td>DOC_CORAL(RX_OAM)
	<td>DOC_CMD_USAGE(ctrl, #ctrl)
	<td>read ATM OAM/RM cells
    <tr><td>DOC_CORAL(RX_LAST)
	<td>DOC_CMD_USAGE(last, #last)
	<td>read last cell of each ATM AAL5 user PDU (packet)
    <tr><td>DOC_CORAL(RX_USER_ALL)
	<td>DOC_CMD_USAGE(user, #user)
	<td>read all bytes of each packet or frame
    <tr><td>DOC_CORAL(RX_ECHO)
	<td>DOC_CMD_USAGE(echo, #echo)
	<td>retransmit received cells on devices which support it
	    (always enabled on POINT cards)
    <tr><td>DOC_CORAL(RX_UNKNOWN)
	<td>
	<td>for traces, read whatever cells are in the
	    trace file; for devices, use default mode
	    (i.e., rx first=48).  Setting this flag clears
	    all other settings.
    </table>
<p>
This function returns 0 for success, -1 for failure.
It only affects sources that are created after it is called.

<p>
Setting VAR(first) overrides a previously set
CODE(DOC_CORAL(RX_USER_ALL)) flag, and
setting the CODE(DOC_CORAL(RX_USER_ALL)) flag
overrides a previously set VAR(first) value.
Attempting to set both at once has undefined results.

<p>
The default I/O mode is DOC_CORAL(RX), and first==48.
Currently, an attempt to explicitly use an I/O mode to read a trace that does
not match the I/O mode used to record the trace will generate a warning,
but all the data in the trace will still be read.
In a future release, the read functions may filter trace files according to
the I/O mode (or generate an error if that is not possible).

<p>
For a
DOC_CMD_USAGE(summary, #sourcenames)
of the iomode options supported by the various interface types,
see the DOC_CMD_USAGE(command usage) document.

<a name="DOC_ID(set_errfile)"></a>
<a name="DOC_ID(set_errfilename)"></a>
<a name="DOC_ID(get_errfile)"></a>
<dt>
DOC_PROTOTYPE(
int <b>coral_set_errfile</b>(FILE *file);
int <b>coral_set_errfilename</b>(const char *filename);
FILE *<b>coral_get_errfile</b>(void);,
<b>set_errfilename</b>(STR filename);
)
<dd>
DOC_BOTH(
    CODE(DOC_IDREF(set_errfile)()) and CODE(DOC_IDREF(set_errfilename)()) set,
    CODE(DOC_IDREF(set_errfilename)()) sets),
the destination for future libcoral error and warning messages.
DOC_C(VAR(file) is an already opened stdio stream pointer, and)
VAR(filename) is the name of a file that will be opened by DOC_name.
Any previously set error file will be closed only if it was set by name other
than "-"DOC_C(
(i.e., by CODE(DOC_IDREF(set_errfilename)()),
but not by CODE(DOC_IDREF(set_errfile)()))).
If DOC_C(VAR(file) or) VAR(filename) is DOC_NULL,
stderr will be used.
If VAR(filename) is CODE("-"), stdout will be used.
DOC_C(CODE(DOC_IDREF(get_errfile)()) returns the current message destination.)
The default message destination is stderr.

<a name="DOC_ID(set_verbosity)"></a>
<a name="DOC_ID(get_verbosity)"></a>
<dt>
DOC_PROTOTYPE(
int <b>coral_set_verbosity</b>(int verbosity);
int <b>coral_get_verbosity</b>(void);,
<b>set_verbosity</b>(NUM verbosity);
<b>get_verbosity</b>();
)
<dd>
Set or get the verbosity level of DOC_nameDOC_C( and CODE(DOC_IDREF(diag)())).
If verbosity==0, only errors are printed;
if verbosity==1 errors and warnings are printed.
DOC_C(Meanings for values greater than 1 may be assigned by the programmer
for use with CODE(DOC_IDREF(diag)()).)
The default verbosity is 1.
To completely disable coral messages, set the verbosity to -1.

<a name="DOC_ID(set_max_pkts)"></a>
<a name="DOC_ID(set_max_cells)"></a>
<a name="DOC_ID(set_max_blks)"></a>
<a name="DOC_ID(get_max_pkts)"></a>
<a name="DOC_ID(get_max_cells)"></a>
<a name="DOC_ID(get_max_blks)"></a>
<dt>
DOC_PROTOTYPE(
int <b>coral_set_max_pkts</b>(uint64_t n);
int <b>coral_set_max_cells</b>(uint64_t n);
int <b>coral_set_max_blks</b>(uint64_t n);
uint64_t <b>coral_get_max_pkts</b>(void);
uint64_t <b>coral_get_max_cells</b>(void);
uint64_t <b>coral_get_max_blks</b>(void);,
<b>coral_set_max_pkts</b>(NUM n);
<b>coral_set_max_cells</b>(NUM n);
<b>coral_set_max_blks</b>(NUM n);
<b>coral_get_max_pkts</b>();
<b>coral_get_max_cells</b>();
<b>coral_get_max_blks</b>();
)
<dd>
These functions get or set the maximum record count that will be read
by the reading APIs.
When the limit is reached, reading functions will indicate EOF.
If set to zero, there is no limit.  All three counts are zero by default.
<table border=1>
<tr><td>count		<td>affected APIs
<tr>
<tr><td>max_pkts	<td>packet
<tr><td>max_cells	<td>cell
<tr><td>max_blks	<td>DOC_C(block and )cell
</table>

<a name="DOC_ID(set_comment)"></a>
<a name="DOC_ID(get_comment)"></a>
<dt>
DOC_PROTOTYPE(
int <b>coral_set_comment</b>(const char *comment);
const char *<b>coral_get_comment</b>(void);,
<b>set_comment</b>(STR comment);
<b>get_comment</b>();
)
<dd>
Set or get the default comment that will be written in the file header by the
CODE(DOC_IDREF(write)) functions.  The default comment may
be overridden by
DOC_BOTH(
CODE(DOC_IDREF(write_set_comment)()),
the VAR(comment) parameter of CODE(DOC_IDREF(write_open)())).

<a name="duration"></a>
<a name="DOC_ID(set_duration)"></a>
<a name="DOC_ID(get_duration)"></a>
<dt>
DOC_PROTOTYPE(
int <b>coral_set_duration</b>(long duration);
long <b>coral_get_duration</b>(void);,
<b>set_duration</b>(NUM duration);
<b>get_duration</b>();
)
<dd>
Set or get the duration value.
<p>
If the duration value is greater than 0, it determines how long libcoral will
read from sources after they are started; after the duration has expired, the
reading function will indicate EOF.  Libcoral uses both real time and
cell timestamps to test duration, so it will work with tracefiles and devices
receiving live traffic.
<p>
With the default duration of -1, the CODE(DOC_IDREF(config)) functions
will not allow duration to be set.
To have your application not use duration by default, but still let the
user override it, set it to 0
before calling the CODE(DOC_IDREF(config)) functions.
<p>
Before version 3.3.0, libcoral did not test duration when reading;
the programmer was expected to handle it himself.
Now, the programmer should do nothing other than enable it,
and let libcoral's reading functions handle the duration.
<p>
Libcoral does not use SIGALRM to implement duration.

<a name="interval"></a>
<a name="DOC_ID(set_interval)"></a>
<a name="DOC_ID(get_interval)"></a>
<dt>
DOC_PROTOTYPE(
int <b>coral_set_interval</b>(struct timeval *interval);
int <b>coral_get_interval</b>(struct timeval *interval);,
<b>set_interval</b>(LIST REF interval);
<b>get_interval</b>();
)
<dd>
Set or get the interval value.
If the interval has not yet been set, CODE(DOC_IDREF(get_interval)())
DOC_C(
returns -1 and fills in *VAR(interval) with { -1, -1 }; otherwise, it
returns 0 and fills in *VAR(interval) with the nonnegative interval value.)
DOC_PERL(
returns (-1, -1, -1); otherwise, it returns (0, sec, usec),
where VAR(sec) and VAR(usec) are the seconds and microseconds,
respectively of a nonnegative interval value.
)
<p>
The interval value is never automatically used by libcoral; it just provides a
convenient and consistent way to let the user set an interval on the command
line or in a config file.  The programmer may use the interval by passing
the result of CODE(DOC_IDREF(get_interval)()) in as a parameter to
CODE(DOC_IDREF(read_pkt_init)()) or
CODE(DOC_IDREF(read_cell_i)()).
Libcoral uses cell timestamps to test for intervals, so the intervals it
reports will be correct for both tracefiles and devices, although the act
of reporting may be delayed because of internal buffering.
<p>
With the default interval of -1, the CODE(DOC_IDREF(config)) functions
will not allow interval to be set.
To have your application not use interval by default, but still let the
user override it, set it to 0.0
before calling the CODE(DOC_IDREF(config)) functions.
<p>
Libcoral does not use SIGALRM to implement interval.

<a name="gzip"></a>
<a name="DOC_ID(set_gzip)"></a>
<dt>
DOC_PROTOTYPE(
int <b>coral_set_gzip</b>(const str *mode);,
<b>set_gzip</b>(STR mode);
)
<dd>
If mode is DOC_NULL, CODE(DOC_IDREF(write_open)()) will not gzip files
unless they end in ".gz".
If mode is "", CODE(DOC_IDREF(write_open)()) will gzip files with the
default parameters (compression level 1).
If mode is a non-empty string,
CODE(DOC_IDREF(write_open)()) will append it to the "wb" mode when calling
CODE(gzopen()); see the zlib documentation for details.

</dl>

<a name="source"><h3>Source Configuration</h3></a>
These functions define and configure sources.  They may only be called
before opening sources.
<dl>

<a name="DOC_ID(new_source)"></a>
<dt>
DOC_PROTOTYPE(
DOC_TYPEREF(Source) *<b>coral_new_source</b>(const char *sourcename);,
<b>new_source</b>(STR sourcename);
)
<dd>
Create a new coral DOC_CMD_USAGE(source, #sources)
from VAR(sourcename).
Sources are described in the
DOC_CMD_USAGE(Command usage, #sources) document.
Returns source pointer if successful, or DOC_NULL for failure.
This function is useful for creating a source directly from the program
(instead of through command line and config file with the
CODE(DOC_IDREF(config)) functions).

<a name="DOC_ID(DOC_BOTH(new_fdsource,new_fsource))"></a>
<dt>
DOC_PROTOTYPE(
DOC_TYPEREF(Source) *<b>coral_new_fdsource</b>(int fd, const char *sourcename);,
<b>new_fsource</b>(FILEHANDLE file, STR sourcename = undef);
)
<dd>
Like DOC_IDREF(new_source), except that it uses the already-open
file DOC_BOTH(descriptor VAR(fd), handle VAR(file))
instead of a filename.
If VAR(sourcename) is not DOC_NULL, CODE(DOC_IDREF(open)())
will examine it for a DOC_CMD_USAGE(prefix or suffix, #sources)
to determine how to interpret the data read from VAR(DOC_BOTH(fd,file));
otherwise, CODE(DOC_IDREF(open)())
will assume data from VAR(DOC_BOTH(fd,file)) contains a
DOC_CMD_USAGE(CoralReef (crl), #crl) trace.
This function is useful for creating a source directly from a
file DOC_BOTH(descriptor, handle) in the program;
for example, a socket connected to another process that used
CODE(DOC_IDREF(DOC_BOTH(write_fdopen,write_fopen))()).
<p>
Mixing CoralReef operations with other operations
on DOC_BOTH(descriptor VAR(fd), handle VAR(file)) may have unpredictable
effects.

<a name="DOC_ID(source_set_iomode)"></a>
<a name="DOC_ID(source_set_iomode_all)"></a>
<dt>
DOC_PROTOTYPE(
int <b>coral_source_set_iomode</b>(DOC_TYPEREF(Source) *src, int off, int on, int first);
int <b>coral_source_set_iomode_all</b>(int off, int on, int first);,
<b>source_set_iomode</b>(SCALAR src, NUM off, NUM on, NUM first = -1);
<b>source_set_iomode_all</b>(NUM off, NUM on, NUM first = -1);
)
<dd>
These functions modify the I/O mode of the indicated already defined sources.
The VAR(off), VAR(on), and VAR(first) arguments are
identical to those of DOC_IDREF(set_iomode)().
These functions return 0 for success, -1 for failure.
<p>
To set the default I/O mode of sources that have not yet been defined, use
DOC_IDREF(set_iomode)().

<a name="DOC_ID(source_set_firmware)"></a>
<a name="DOC_ID(source_set_firmware_all)"></a>
<dt>
DOC_PROTOTYPE(
int <b>coral_source_set_firmware</b>(DOC_TYPEREF(Source) *src, const char *firmware);
int <b>coral_source_set_firmware_all</b>(const char *firmware);,
<b>source_set_firmware</b>(SCALAR src, STR firmware);
<b>source_set_firmware_all</b>(STR firmware);
)
<dd>
Set the location of the firmware file of source VAR(src),
or of all sources.  The firmware will be loaded when the source is opened.
Returns 0 for success, -1 for failure.

</dl>

<a name="opening"><h3>Opening</h3></a>
Sources must be DOC_REF(opened, #DOC_ID(open)) and
DOC_REF(started, #DOC_ID(start)) before they can be read.
When they are no longer needed, they may be DOC_REF(stopped, #DOC_ID(stop))
and should be DOC_REF(closed, #DOC_ID(close)).
Note that failing to close a DAG card source may leave it in an unusable state
(CODE(/proc/dag) will report the device is "Busy");
the card must be re-initialized before CoralReef can read from it again.

<dl>

<a name="DOC_ID(open)"></a>
<a name="DOC_ID(open_all)"></a>
<dt>
DOC_PROTOTYPE(
int <b>coral_open</b>(DOC_TYPEREF(Source) *src);
int <b>coral_open_all</b>(void);,
<b>open</b>(SCALAR src);
<b>open_all</b>();
)
<dd>
Open the indicated coral DOC_REF(sources, #intro) that have been created by
CODE(DOC_IDREF(config_arguments)()), CODE(DOC_IDREF(config_options)()),
CODE(DOC_IDREF(config_command)()), and CODE(DOC_IDREF(new_source)()),
but do not start them.
If successful, these functions return the number of interfaces opened.
If unsuccessful, these functions return -1 and DOC_REF(close, #DOC_ID(close))
the source which failed.
Note that a single tracefile source may contain multiple interfaces.

<a name="DOC_ID(start)"></a>
<a name="DOC_ID(start_all)"></a>
<dt>
DOC_PROTOTYPE(
int <b>coral_start</b>(DOC_TYPEREF(Source) *src);
int <b>coral_start_all</b>(void);,
<b>start</b>(SCALAR src);
<b>start_all</b>();
)
<dd>
Start capture on interface(s) of the indicated coral sources which have been
opened with CODE(DOC_IDREF(open)()) or CODE(DOC_IDREF(open_all)()).
Addtionally, CODE(DOC_IDREF(start_all)()) resets the clocks of all
open interfaces that allow it, to synchronize them.
A source can not be read until it is started with one of these functions.
(Prior to version 3.3, it was not strictly necessary to start tracefile
sources.)

<a name="DOC_ID(stop_all)"></a>
<a name="DOC_ID(stop)"></a>
<dt>
DOC_PROTOTYPE(
int <b>coral_stop_all</b>(void);
int <b>coral_stop</b>(DOC_TYPEREF(Source) *src);,
<b>stop_all</b>();
<b>stop</b>(SCALAR src);
)
<dd>
Stop capturing on all interfaces of the indicated device sources.
Returns 0 for success, -1 for failure.
After a source is stopped, it may still contain buffered data, which can be
read until the reading function returns an EOF indication.
These functions are not safe to call asynchronously
(e.g., from a signal handler).
DOC_C(
<p>
See also:  DOC_IDREF(pkt_done).)

<a name="DOC_ID(close_all)"></a>
<a name="DOC_ID(close)"></a>
<dt>
DOC_PROTOTYPE(
int <b>coral_close_all</b>(void);
int <b>coral_close</b>(DOC_TYPEREF(Source) *src);,
<b>close_all</b>();
<b>close</b>(SCALAR src);
)
<dd>
Close all interfaces of the indicated sources, after flushing any partially
filled blocks.
Returns 0 for success, -1 for failure.

</dl>


<a name="packet"><h3>Packet Reading</h3></a>
The packet reading functions may be used with any CoralReef interface that has
been DOC_REF(started, #DOC_ID(start)).
All time is measured against packet
timestamps, so it works even for trace files that aren't in real time.
DOC_C(See CODE(crl_print_pkt.c) for a good example of using the packet API.)

DOC_C(
<a name="single packet"></a>
<h4>Single packet reading</h4>
)
<dl>
<a name="DOC_ID(read_pkt_init)"></a>
<dt>
DOC_PROTOTYPE(
int <b>coral_read_pkt_init</b>(DOC_TYPEREF(Source) *src, DOC_TYPEREF(Iface) *iface,
    struct timeval *interval);,
<b>read_pkt_init</b>(SCALAR src, SCALAR iface, LIST REF interval = undef);
)
<dd>
Prepare to read packets from an open VAR(src) or VAR(iface) with
CODE(DOC_IDREF(read_pkt)()).
If VAR(iface) is not DOC_NULL,
packets will be read from VAR(iface);
otherwise, if VAR(src) is not DOC_NULL,
packets will be read from all interfaces of VAR(src);
otherwise, packets will be read from all interfaces of all open sources.
There is no restriction on reading multiple pcap sources or mixing pcap and
OCx sources, as there was prior to version 3.4.
If VAR(iface) belongs to a source with multiple interfaces, data
from the other interfaces of that source will be discarded.
Packets can be read from only one set of sources at a time;
calling CODE(DOC_IDREF(read_pkt_init)()) invalidates any sources that were
previously initialized for packet reading.
VAR(Interval) is the amount of time CODE(DOC_IDREF(read_pkt)())
will wait between returning statistical information (measured against packet
timestamps).
DOC_PERL(
To set the interval, give CODE(DOC_IDREF(read_pkt_init)()) a
reference to a 2-element array representing the seconds
and microseconds of the interval, such as [100, 0], which might
come from CODE(DOC_IDREF(get_interval)()).
<var>Interval</var> defaults to DOC_NULL, which disables interval handling.
CODE(DOC_IDREF(read_pkt_init)()) returns 0 if successful, or -1 if an
error occurs.
)
<p>
Because CODE(DOC_IDREF(read_pkt)()) implicitly
sorts packets by timestamp, the packet timestamps must be comparable.
If necessary,
CODE(DOC_IDREF(read_pkt_init)())
will automatically enable the
DOC_OPT(NORMALIZE_TIME)
option to guarantee that the timestamps are comparable.
<p>
CODE(DOC_IDREF(read_pkt_init)()) returns 0 if successful, or -1 if an
error occurs.

<a name="DOC_ID(read_pkt)"></a>
<dt>
DOC_PROTOTYPE(
DOC_IDREF(iface_t) *<b>coral_read_pkt</b>(DOC_TYPEREF(Pkt_result) *pkt_result,
    DOC_IDREF(interval_result_t) *interval_result);,
<b>read_pkt</b>(DOC_TYPEREF(Pkt_result)_REF pkt_result, DOC_TYPEREF(Interval_result)_REF interval_result = undef);
)
<dd>
Read a packet from one of the interfaces which have been
initialized with CODE(DOC_IDREF(read_pkt_init)()).
If a DOC_REF(packet filter, #DOC_ID(add_pcap_filter)) has been set, only
packets that match the filter will be read.
Packets read are always sorted by time, regardless of the setting of the
DOC_OPT(SORT_TIME) option.
If the DOC_OPT(PARTIAL_PKT)
option is turned <em>off</em>, only complete packets will be read
(but truncated packets are always counted by the VAR(truncated) field of
DOC_TYPEREF(Pkt_stats)).
<p>
VAR(pkt_result) and VAR(interval_result) are
DOC_BOTH(
pointers to structures (allocated by the programmer),
references to objects created by the user
)
that will be filled in by the call.
For success, CODE(DOC_IDREF(read_pkt)()) returns DOC_C(a pointer to the )
interface which was read,
and the contents of the DOC_BOTH(structures, objects) indicate what happened:
<p>

<dl>
DOC_BOTH(
<dt>CODE(if (pkt_result-&gt;packet != NULL) {),
<dt>CODE(if (defined pkt_result-&gt;packet) {)
)
    <dd>A packet was read; information about the packet is contained in
    CODE(pkt_result).<br>
    CODE(pkt_result-&gt;packet) will DOC_BOTH(point to, reference) a
    DOC_TYPEREF(Pkt_buffer)
    containing the link layer (LLC/SNAP, ethernet, etc) PDU.
    On ATM interfaces,
    CODE(pkt_result-&gt;header) will DOC_BOTH(point to, reference) a
    DOC_TYPEREF(Pkt_buffer)
    containing the first 4 bytes of the ATM header of the last captured cell
    of the packet (in network byte order);
    CODE(pkt_result-&gt;trailer) will DOC_BOTH(point to, reference) a
    DOC_TYPEREF(Pkt_buffer)
    containing the AAL5 trailer (in network byte order), if available; and
    CODE(pkt_result-&gt;subiface) will contain the ATM vpvc
    (in host byte order) from which the packet was read.
    On IEEE 802.3/Ethernet interfaces carrying IEEE 802.1Q VLAN traffic, 
    CODE(pkt_result-&gt;subiface) will be the VLAN ID.
    On other types of interfaces, CODE(pkt_result-&gt;header)
    and CODE(pkt_result-&gt;trailer) will be DOC_NULL,
    and CODE(pkt_result-&gt;subiface) will be 0.
DOC_BOTH(
<dt>CODE(} else if (interval_result-&gt;stats == NULL) {),
<dt>CODE(} elsif (not defined interval_result-&gt;stats) {)
)
    <dd>An interval has begun at time CODE(interval_result-&gt;begin).
    (CODE(interval_result-&gt;end) is not valid.)
<dt>CODE(} else {)
    <dd>The interval begun at time CODE(interval_result-&gt;begin) and
    ending at CODE(interval_result-&gt;end) has ended.
    Statistics for the interval are contained in
    CODE(interval_result-&gt;stats).
<dt>CODE(})
</dl>

<p>
If the VAR(interval) specified in CODE(DOC_IDREF(read_pkt_init)()) was
DOC_NULL or 0,
VAR(interval_result) may be DOC_PERL(omitted or )DOC_NULL,
and CODE(DOC_IDREF(read_pkt)()) will never return with
CODE(pkt_result-&gt;packet == DOC_NULL).
The beginning of an interval is <em>not</em> aligned to a multiple of
the interval size.
When reading from a live interface, internal buffering may cause reporting of
the end of the interval to be delayed, but the data reported will cover exactly
the requested interval.
(In versions 3.2.x, the reported interval included "quiet" (trafficless) time
after the end of the requested time.
In versions 3.1 and earlier, the data reported
included packets past the end of the interval that fell in the same internal
buffer as the end of the interval.)  Interval comparisons are made against
packet timestamps, not a real clock, so the same results will be produced by
reading a live interface or reading a trace taken on that interface in the
same period.
<p>
The protocol of CODE(pkt_result-&gt;packet) is determined by the interface type.
For ATM interfaces, the protocol is determined by the virtual channel and
DOC_CMD_USAGE(CODE(proto), #proto)
configuration rules DOC_C(as by CODE(DOC_IDREF(proto_rule)())).
Note that if the configuration is incorrect, the packet buffer will
not make sense.
For TSH interfaces, the protocol for a valid packet is always
DOC_PROTO(NETPROTO_IPv4),
and IP options are always zero; the protocol of an invalid packet is
DOC_PROTO(PROTO_UNKNOWN).
<p>
DOC_C(
If DOC_IDREF(cell_block_hook) points to a
programmer-defined function, it will be called when a new block of ATM cells
is read.
)
<p>
To indicate EOF, a DOC_REF(stopped, #DOC_ID(stop)) device, or
expired DOC_REF(duration, #duration),
CODE(DOC_IDREF(read_pkt)()) returns
DOC_NULL with CODE(DOC_errno == 0).
For an error, CODE(DOC_IDREF(read_pkt)())
returns DOC_NULL with
CODE(DOC_errno) set to indicate the type of error.
(Certain types of errors that were reported as EOF in versions prior 3.5
are now correctly reported as errors.)
<p>
If DOC_IDREF(get_verbosity)() &gt;= 1, then
at the end of every interval, 
if there were any packet errors
(nonzero fields in CODE(interval_result-&gt;stats))
during the interval,
CODE(DOC_IDREF(read_pkt)())
prints warnings to the DOC_REF(error file, #DOC_ID(set_errfilename)).
If intervals were not used, the warnings are printed only at EOF,
covering the entire duration.
</dl>

DOC_C(
<a name="callback packet"></a>
<h4>Callback loop packet reading</h4>
<dl>
<a name="DOC_ID(read_pkts)"></a>
<dt>
<pre>
int <b>coral_read_pkts</b>(DOC_TYPEREF(Source) *src, DOC_TYPEREF(Iface) *iface,
		DOC_IDREF(pkt_handler) pkthandler, 
		DOC_IDREF(pre_interval_handler) preinthandler, 
		DOC_IDREF(post_interval_handler) postinthandler,
		struct timeval *interval,
		void *mydata);
</pre>
<dd>
Reads packets from one or more interfaces, and calls a handler function
for each packet read and for the beginning and end of each interval.
VAR(Src), VAR(iface), and VAR(interval)
are interpreted as in CODE(DOC_IDREF(read_pkt_init)()).
CODE(DOC_IDREF(read_pkts)()) repeatedly reads link level packets
(using DOC_IDREF(read_pkt)())
until CODE((coral_pkt_done != 0))
or EOF is reached on all interfaces.
<p>
VAR(Pkthandler) is a pointer to a function that will be called for
each packet received.
<p>
VAR(Preinthandler) and VAR(postinthandler) are pointers to
functions that will be called before and after each interval of approximately
*VAR(interval) seconds in which packets were received.
VAR(Preinthandler) and VAR(postinthandler) are not called if they
are DOC_NULL, VAR(interval) is DOC_NULL,
or *VAR(interval) is less than or equal to 0.0.
<p>
VAR(Mydata) will be passed
as a parameter to the handler functions, but otherwise ignored; the programmer
may use it as needed.
<p>
VAR(Postinthandler) may set CODE(coral_pkt_done) to nonzero to
make CODE(DOC_IDREF(read_pkts)()) stop looping and return.
<p>
CODE(DOC_IDREF(read_pkts)()) returns 0 if it reaches EOF with no errors;
or -1 if there is an error, with errno set to indicate the type of error.
(Certain types of errors that were reported as EOF in versions prior 3.5
are now correctly reported as errors.)
)

DOC_C(
<a name="DOC_ID(pkt_handler)"></a>
<dt>
<pre>
typedef void (*<b>coral_pkt_handler</b>)(DOC_TYPEREF(Iface) *iface,
    const DOC_TYPEREF(Timestamp) *timestamp, void *mydata,
    DOC_TYPEREF(Pkt_buffer) *packet, DOC_TYPEREF(Pkt_buffer) *header,
    DOC_TYPEREF(Pkt_buffer) *trailer);
</pre>
<dd>
CODE(coral_pkt_handler) is the type of the function called each time
CODE(DOC_IDREF(read_pkts)()) reads a packet.
Parameters:
    <dl>
    <dt>VAR(iface)
        <dd>a pointer to the interface from which the packet was read.
    <dt>VAR(timestamp)
        <dd>the time at which the packet was read (usable with the
	DOC_IDREF(read_clock) functions).
    <dt>VAR(mydata)
        <dd>the VAR(mydata) parameter that was passed to
        CODE(DOC_IDREF(read_pkts)()).
    <dt>VAR(packet)
        <dd>a pointer to a DOC_TYPEREF(Pkt_buffer)
	containing a link level packet, not including a trailer.
    <dt>VAR(header)
        <dd>a pointer to a DOC_TYPEREF(Pkt_buffer)
	containing the header used at a next lower layer, or DOC_NULL.
	Currently, this is only used for the ATM header of the last received
	cell in the packet; the ATM header will be in network byte order
	(in version 3.1, this was in host byte order).
    <dt>VAR(trailer)
        <dd>a pointer to a DOC_TYPEREF(Pkt_buffer)
	containing the trailer used at a next lower layer,
	if the lower layer uses trailers and the packet was not truncated;
	otherwise, DOC_NULL.
	Currently, this is only used for the ATM AAL5 trailer.
    </dl>
)

DOC_C(
<a name="DOC_ID(pre_interval_handler)"></a>
<a name="DOC_ID(post_interval_handler)"></a>
<dt>
<pre>
typedef void (*<b>coral_pre_interval_handler</b>)(DOC_TYPEREF(Iface) *iface,
	const struct timeval *begin, void *mydata);
typedef void (*<b>coral_post_interval_handler</b>)(DOC_TYPEREF(Iface) *iface,
	const struct timeval *begin, const struct timeval *end,
	void *mydata, const DOC_TYPEREF(Pkt_stats) *stats);
</pre>
<dd>
CODE(coral_pre_interval_handler) and CODE(coral_post_interval_handler)
are the types of the functions called before and after (respectively) each
interval of CODE(DOC_IDREF(read_pkts)()).
Parameters:
    <dl>
    <dt>VAR(iface)
        <dd>the interface being read.
    <dt>VAR(begin)
        <dd>the beginning of the interval.
    <dt>VAR(mydata)
        <dd>the VAR(mydata) parameter that was passed to
        CODE(DOC_IDREF(read_pkts)())
    <dt>VAR(stats)
        <dd>a pointer to a structure containing statistics about the interval,
	summed across all interfaces.
	(To get statistics for an individual interface, use
	DOC_IDREF(get_iface_stats)().)
    </dl>
</dl>
)

<a name="other packet"></a>
<h4>Other packet reading features</h4>
<dl>

DOC_C(
<a name="DOC_ID(get_iface_stats)"></a>
<dt>
<pre>
const DOC_TYPEREF(Pkt_stats) *<b>coral_get_iface_stats</b>(DOC_TYPEREF(Iface) *iface)
</pre>
<dd>
Returns a DOC_BOTH(pointer, reference) to the 
DOC_TYPEREF(Pkt_stats) structure for
VAR(iface) for the most recent interval.
)

DOC_C(
<a name="DOC_ID(pkt_done)"></a>
<dt>
<pre>
extern volatile int <b>coral_pkt_done</b>;
</pre>
<dd>
This can be set to a non-zero value at any time
(e.g., in postblkhandler or in a signal handler)
to force either packet reading function to act like it has detected EOF
the next time it is called, on both device and trace file sources.
<p>
See also: CODE(DOC_IDREF(stop_all)()).
)

DOC_C(
<a name="DOC_ID(pkt_atm_hook)"></a>
<dt>
<pre>
extern int (*<b>coral_pkt_atm_hook</b>)(const DOC_TYPEREF(Iface) *iface,
	const DOC_TYPEREF(Pkt_buffer) *packet, const DOC_TYPEREF(Atm_cell) *cell);
</pre>
<dd>
If CODE(coral_pkt_atm_hook) is not DOC_NULL, the function
to which it points is called each time the first cell of an AAL5 PDU is seen by
CODE(DOC_IDREF(read_pkt)()) or
CODE(DOC_IDREF(read_pkts)())
on an ATM interface.
If this function returns 0, the packet reader function will skip
the packet to which the cell belongs;
if it returns nonzero, or the function pointer is DOC_NULL,
the packet reader function will process the packet normally.
The CODE(coral_pkt_atm_hook) test is done before any reassembly is
performed, so it is more efficient to discard packets in
CODE(coral_pkt_atm_hook) than after
CODE(DOC_IDREF(read_pkt)()) returns or in the
CODE(coral_pkt_handler) of
CODE(DOC_IDREF(read_pkts)()).
The parameters are:
<dl>
    <dt>VAR(iface)
	<dd>pointer to the interface from which the cell was read
    <dt>VAR(packet)
	<dd>pointer to a packet structure containing as much data about the
	data link level packet as was available in the first cell.
	This is provided for convenient use with functions that take a
	CODE(DOC_TYPEREF(Pkt_buffer))
	parameter (e.g.,
	CODE(DOC_IDREF(get_payload)())).
    <dt>VAR(cell)
	<dd>pointer to the first cell (in network byte order).
</dl>
The default value of CODE(coral_pkt_atm_hook) is DOC_NULL.
<p>
See also: DOC_IDREF(add_pcap_filter)() and
DOC_IDREF(pcap_setfilter)().
)

<a name="DOC_ID(get_payload)"></a>
<dt>
DOC_PROTOTYPE(
int <b>coral_get_payload</b>(const DOC_TYPEREF(Pkt_buffer) *src, DOC_TYPEREF(Pkt_buffer) *dst);,
<b>get_payload</b>(DOC_TYPEREF(Pkt_buffer)_REF src, DOC_TYPEREF(Pkt_buffer)_REF dst);
)
<dd>
VAR(src) is a DOC_BOTH(pointer, reference) to a
DOC_TYPEREF(Pkt_buffer)
containing a datagram or packet
(e.g., VAR(packet_result-&gt;packet) from DOC_IDREF(read_pkt)())
with CODE(VAR(src)-&gt;caplen &gt; 0).
DOC_PERL(
VAR(Dst) is also a reference to a DOC_TYPEREF(Pkt_buffer),
but is created by the user, eg:
"CODE($argument = new DOC_TYPEREF(Pkt_buffer);)".
)
CODE(DOC_IDREF(get_payload)()) skips past the lower level (outer) protocol
encapsulation in VAR(src) and fills in VAR(dst) with information
about the payload of VAR(src)
(see DOC_TYPEREF(Pkt_buffer)).
If CODE(DOC_IDREF(get_payload)()) understands the VAR(src) protocol
but does not recognize the protocol of the payload,
CODE(VAR(dst)-&gt;protocol) will contain
DOC_PROTO(PROTO_UNKNOWN) or some other undefined value.
<p>
CODE(DOC_IDREF(get_payload)()) returns 0 if it successfully parsed
the VAR(src) protocol information, or one of the following negative
error codes:
<dl compact>
<dt>DOC_CORAL(ENOPROTO)	<dd>libcoral does not support the protocol
<dt>DOC_CORAL(ELENGTH)	<dd>protocol information was truncated
<dt>DOC_CORAL(ESYNTAX)	<dd>packet data are inconsistent with protocol
<dt>DOC_CORAL(ERROR)	<dd>other error
</dl>
The recognized protocols are listed in the
DOC_CMD_USAGE(Protocols, #protocols) section of the
DOC_CMD_USAGE(Command Usage) document.  
Protocol identifiers are formed by concatenating
DOC_BOTH(
"CODE(CORAL_)", the prefix, and the name;,
the prefix and the name, in the Coral namespace;
)
e.g., DOC_PROTO(DLT_ATM_RFC1483).
<p>
This function treats IPv6 extension headers as encapsulated protocols.
So, for example, say you have an Ethernet frame containing an IPv6 packet
with a Routing header, Fragment header, and UDP datagram.
If you call CODE(DOC_IDREF(get_payload)()) with that packet as VAR(src),
and then repeatedly with the VAR(dst) of the previous call as the VAR(src)
of the next,
the value of CODE(VAR(dst)-&gt;protocol) 
after each successive call would be
DOC_PROTO(NETPROTO_IPv6),
DOC_PROTO(IPPROTO_ROUTING),
DOC_PROTO(IPPROTO_FRAGMENT),
DOC_PROTO(IPPROTO_UDP), and
DOC_PROTO(PROTO_UNKNOWN),
respectively.
<p>
Note:  DOC_CMD_USAGE(TSH files, #sourcenames)
contain IPv4 packet headers only, and when CoralReef reads an IPv4
packet from a DOC_CMD_USAGE(TSH file, #sourcenames)
it fills the missing IP options (if any) with zeros to create
a syntactically valid substring of an IP packet.

<a name="DOC_ID(fmt_get_payload)"></a>
<dt>
DOC_PROTOTYPE(
int <b>coral_fmt_get_payload</b>(const DOC_TYPEREF(Pkt_buffer) *src,
    DOC_TYPEREF(Pkt_buffer) *dst, char *buf, int len);,
<b>fmt_get_payload</b>(DOC_TYPEREF(Pkt_buffer)_REF src, DOC_TYPEREF(Pkt_buffer)_REF dst, STR REF buf);
)
<dd>
CODE(DOC_IDREF(fmt_get_payload)()) is like
CODE(DOC_IDREF(get_payload)()), except that it also writes
DOC_C(up to VAR(len) characters (including a terminating null character) of)
human-readable information about the lower level protocol into VAR(buf).
Returns a nonnegative number if successful,
or -1 for any of the following errors:
CODE(vsnprintf()) is not available on your system
and VAR(buf) is not DOC_NULL;
or any of the errors listed in the documentation for
DOC_IDREF(get_payload)().
<p>
The information written into buf attempts to cover all relevant information
about the protocol.  Irrelevant information is omitted for brevity (for
example: for TCP, the urgent pointer is printed only if the URG flag is set;
for IPv4, type-of-service is printed only if it is nonzero,
and the fragment offset is printed only if the packet is a fragment).
The IP checksum will be printed and verified only if the
DOC_OPT(IP_CKSUM)
option is set.

<a name="DOC_ID(get_payload_by_proto)"></a>
<a name="DOC_ID(get_payload_by_layer)"></a>
<dt>
DOC_PROTOTYPE(
int <b>coral_get_payload_by_proto</b>(const DOC_TYPEREF(Pkt_buffer) *src,
    DOC_TYPEREF(Pkt_buffer) *dst, DOC_TYPEREF(Protocol) proto);
int <b>coral_get_payload_by_layer</b>(const DOC_TYPEREF(Pkt_buffer) *src,
    DOC_TYPEREF(Pkt_buffer) *dst, int layer);,
<b>get_payload_by_proto</b>(DOC_TYPEREF(Pkt_buffer)_REF src, DOC_TYPEREF(Pkt_buffer)_REF dst, NUM proto);
<b>get_payload_by_layer</b>(DOC_TYPEREF(Pkt_buffer)_REF src, DOC_TYPEREF(Pkt_buffer)_REF dst, NUM layer);
)
<dd>
These functions search for the outermost packet in VAR(src) whose
protocol is VAR(proto) or protocol layer is VAR(layer), and
copy that packet's information to VAR(dst).
The copied packet will be VAR(src) itself if its protocol matches the
criterion; otherwise these functions repeatedly call
DOC_IDREF(get_payload)()
to find encapsulated packets.
These functions return 0 if successful, or -1 if
the VAR(proto) or VAR(layer) is not found,
or for any of the errors listed in the documentation for
DOC_IDREF(get_payload)().

DOC_C(
<a name="DOC_ID(get_net_pkt)"></a>
<dt>
<pre>
const char *<b>coral_get_net_pkt</b>(const DOC_TYPEREF(Pkt_buffer) *buffer, int *protocol);
</pre>
<dd>
Obsolete.  See DOC_IDREF(get_payload)()
)

</dl>

<a name="pcap filtering"></a>
<h4>Pcap packet filtering</h4>
If libcoral was compiled with libpcap, these functions can be used to set
pcap filter expressions.
Pcap filters can be used with any type of interface, not just BPF devices.
The filter will be executed when it is most efficient:  
in the kernel if the interface is a BPF device,
or before AAL5 reassembly (if possible) if the interface is an ATM
Coral device or file.
The DOC_REF(packet reading functions, #packet) will return only
packets which match the filter.

<dl>

<a name="DOC_ID(add_pcap_filter)"></a>
<dt>
DOC_PROTOTYPE(
int <b>coral_add_pcap_filter</b>(const char *expr),
<b>add_pcap_filter</b>(STR expr)
)
<dd>
If VAR(expr) is not DOC_NULL, CODE(DOC_IDREF(add_pcap_filter)())
sets VAR(expr) as a global pcap filter expression.
If a filter expression was already set (either by this function or by
DOC_IDREF(config) DOC_CMD_USAGE("filter", #filter) commands),
the old and new expressions are joined as
"CODE((VAR(old_expr)) and (VAR(expr)))".
The expression will be compiled and set on every source that is subsequently
opened; it has no effect on sources that are already open.
<p>
If VAR(expr) is DOC_NULL,
CODE(DOC_IDREF(add_pcap_filter)()) clears
any previously set global pcap filter expression.
<p>
This function will not work until CODE(DOC_IDREF(set_api)(DOC_CORAL(API_PKT)))
is called.
This function returns 0 if successful,
or -1 with DOC_errno set if there is an error.
<p>
See also the section on DOC_CMD_USAGE(-Cfilter, #filter)
in the DOC_CMD_USAGE(command usage) document.

<a name="DOC_ID(get_pcap_filter)"></a>
<dt>
DOC_PROTOTYPE(
const char *<b>coral_get_pcap_filter</b>(void),
<b>get_pcap_filter</b>()
)
<dd>
Returns the text of the global pcap filter expression
previously set by
DOC_IDREF(add_pcap_filter)()
and/or by DOC_IDREF(config) DOC_CMD_USAGE("filter", #filter) commands.
Returns DOC_NULL if no filter expression has been set.

<a name="DOC_ID(pcap_compile)"></a>
<a name="DOC_ID(pcap_setfilter)"></a>
<dt>

DOC_C(
<pre>
int <b>coral_pcap_compile</b>(DOC_TYPEREF(Iface) *iface, struct bpf_program *fp, char *str,
    int optimize, uint32_t netmask);
int <b>coral_pcap_setfilter</b>(DOC_TYPEREF(Iface) *iface, struct bpf_program *fp);
</pre>
<dd>
If you need finer control over pcap filtering than
DOC_IDREF(add_pcap_filter)() provides,
you can use these two functions.  These allow you to recompile and reset
filters at any time (even on interfaces that are already open), and
to assign different filters to different interfaces.
<p>
These two functions are the same as CODE(pcap_compile()) and
CODE(pcap_setfilter()), respectively, except that they apply to a
CODE(DOC_TYPEREF(Iface)) instead of a
CODE(pcap_t).  They are used to compile a tcpdump expression to a
BPF program and install
it onto a Coral interface.  Note that CODE(*VAR(fp)) must remain
in valid memory until VAR(iface) is closed or a new BPF program is
installed on VAR(iface).
<p>
To avoid confusion when using these functions, you should set the
DOC_OPT(NO_FILTER) option
before calling the DOC_IDREF(config) functions
to prevent the user from specifying a useless DOC_CMD_USAGE("filter", #filter) command.
Alternatively, you could allow the user to use DOC_CMD_USAGE("filter", #filter) commands,
use DOC_IDREF(get_pcap_filter)()
to get it so you can combine it with yours, and 
CODE(DOC_IDREF(add_pcap_filter)(NULL))
to clear the global expression so it won't be applied by
DOC_IDREF(open)().
<p>
These functions require including the pcap header CODE(&lt;pcap.h&gt;).
<p>
See the DOC_REF(pcap and tcpdump documentation, http://www.tcpdump.org/)
for more information.
)

</dl>

DOC_C(
<a name="packet-ex"></a>
<h4>Packet reading example</h4>
<pre>
static int count_and_print_pkt(DOC_TYPEREF(Iface) *iface,
    const DOC_TYPEREF(Timestamp) *timestamp, void *mydata,
    DOC_TYPEREF(Pkt_buffer) *buffer, DOC_TYPEREF(Pkt_buffer) *header,
    DOC_TYPEREF(Pkt_buffer) *trailer)
{
    long *countp = mydata;

    ++(*countp);
    if (buffer-&gt;caplen == buffer-&gt;totlen)  /* complete capture? */
        printf("bytes: %d\n", buffer-&gt;caplen);
    else
        printf("bytes: %d (of %d)\n", buffer-&gt;caplen, buffer-&gt;totlen);
    dump_packet(timestamp, buffer-&gt;buf);
}

int main()
{
    long count;
    ...
    count = 0;
    DOC_IDREF(read_pkts)(src, NULL, count_and_print_pkt, NULL, NULL, 0, &amp;count);
    printf("received %ld packets.\n", count);
    ...
}
</pre>
)


<a name="cell"></a>
<h3>DOC_BOTH(Cell/Block, Cell) Reading</h3></a>
<a name="cell-general"></a>
<h4>General Description</h4>
<p>
The DOC_C(block and )cell reading functions may be used only with ATM interfaces
that have been DOC_REF(started, #DOC_ID(start)).
DOC_C(The cell functions are more general than the block functions.)
For working with layers 3 and above,
the DOC_REF(packet reading functions, #packet) are usually better.
<p>
After any of these reading functions are successful,
DOC_BOTH(
*VAR(cellp) will point to a single DOC_REF(cell, #DOC_TYPE(atm_cell))
(for the cell functions)
or array of DOC_REF(cells, #DOC_TYPE(atm_cell))
(for the block functions);
and if VAR(binfop) is not DOC_NULL,
*VAR(binfop) will point to a
DOC_REF(block info structure, #DOC_TYPE(blk_info))
describing the block to which the cell or cells belong.
All structures will be in network byte order.  (In version 3.0, cells
read from FATM devices had ATM headers in little endian order.)
, 
VAR(binfop) will be a reference to a byte string representing the block info,
and VAR(cellp) will be a reference to a DOC_TYPEREF(Cell) object.
VAR(binfop) can be parsed by the DOC_REF(Unpack, ../libsrc/CRL/doc/Unpack.html) functions.
)
VAR(binfop) may be passed a value of DOC_NULL if the block info will not be
needed.
<p>
If VAR(timeout) is DOC_NULL or omitted,
these functions will wait until data are available or an interrupt occurs.
But if VAR(timeout) is not DOC_NULL,
these functions will also return after
the amount of time specified in VAR(timeout) even if there are no data.
DOC_PERL(
To set the timeout, input a reference to a
2-element array representing the seconds and microseconds
of the timeout, such as [100, 0].
)
<p>
DOC_C(
If DOC_IDREF(cell_block_hook) is not DOC_NULL,
the function to which it points will be called when a new block of ATM cells is
read by any of the cell reading functions.
)
<p>
The DOC_CMD_USAGE(CODE(deny), #deny) protocol rules
are applied by the cell reading functions
to filter the cells and determine their protocol.
DOC_C(
They are not applied by the block reading functions.
In either case, no protocol information is given;
use DOC_IDREF(proto_rule) to get that.
)
Note:  prior to version 3.4.2, the cell reading functions did not apply
the the configuration DOC_CMD_USAGE(CODE(deny), #deny) rules.
<p>
Calls to the different CoralReef reading functions
may not be interleaved on a given set of sources.
<p>
A call to any CoralReef reading function on a given set
of sources invalidates all data in buffers set by previous calls to
any reading functions on the same set of sources.

<a name="cell-return"></a>
<h4>Return values</h4>
<ul>
<li>DOC_NULL with CODE(DOC_errno==0) for EOF,
DOC_REF(stopped, #DOC_ID(stop)) device, or
expired DOC_REF(duration, #duration).
(If end-of-file is encountered someplace other than a block boundary, it
is considered an error.)
<li>CODE(DOC_NULL) with CODE(DOC_errno==EAGAIN) if VAR(timeout) is exceeded
<li>CODE(DOC_NULL) with CODE(DOC_errno==EBADF) if sources are not ATM.
<li>CODE(DOC_NULL) with other DOC_errno value for other errors
<li>non-CODE(DOC_NULL) interface DOC_BOTH(pointer, reference) for success
</ul>
(Certain types of errors that were reported as EOF in versions prior 3.5
are now correctly reported as errors.)
<p>

<a name="cell-read"></a>
<h4>Reading Functions</h4>
<dl>
<a name="DOC_ID(read_cell)"></a>
<a name="DOC_ID(read_cell_all)"></a>
<dt>
DOC_PROTOTYPE(
DOC_TYPEREF(Iface) *<b>coral_read_cell</b>(DOC_TYPEREF(Source) *src, DOC_TYPEREF(Blk_info) **binfop,
    DOC_TYPEREF(atm_cell) **cellp, struct timeval *timeout);
DOC_TYPEREF(Iface) *<b>coral_read_cell_all</b>(DOC_TYPEREF(Blk_info) **binfop,
    DOC_TYPEREF(atm_cell) **cellp, struct timeval *timeout);,
<b>read_cell</b>(SCALAR src, STR REF binfop, DOC_TYPEREF(Cell)_REF cellp, LIST REF timeout = undef);
<b>read_cell_all</b>(STR REF binfop, DOC_TYPEREF(Cell)_REF cellp, LIST REF timeout = undef);
)
<dd>
CODE(DOC_ID(read_cell)()) reads a single cell from the indicated source;
CODE(DOC_ID(read_cell_all)()) reads from all open sources.
If the DOC_OPT(SORT_TIME) option is off,
CODE(DOC_IDREF(read_cell_all)()) reads cells in the most
efficient order (i.e., block order);
but if the DOC_OPT(SORT_TIME)
option is on, it will read them
in time-sorted order (interleaving cells from blocks of different interfaces).
If the DOC_OPT(SORT_TIME) is set,
VAR(timeout) is ignored (it is always treated as DOC_NULL).
<p>
See the section introduction above for
DOC_REF(more details, #cell-general) and
DOC_REF(return values, #cell-return).

<a name="DOC_ID(read_cell_i)"></a>
<a name="DOC_ID(read_cell_all_i)"></a>
<dt>
DOC_PROTOTYPE(
DOC_TYPEREF(Iface) *<b>coral_read_cell_i</b>(DOC_TYPEREF(Source) *src, DOC_TYPEREF(Blk_info) **binfop,
    DOC_TYPEREF(atm_cell) **cellp, DOC_TYPEREF(Interval_result) *int_result,
    struct timeval *interval);
DOC_TYPEREF(Iface) *<b>coral_read_cell_all_i</b>(DOC_TYPEREF(Blk_info) **binfop,
    DOC_TYPEREF(atm_cell) **cellp, DOC_TYPEREF(Interval_result) *int_result,
    struct timeval *interval);,
<b>read_cell_i</b>(SCALAR src, STR REF binfop,
	    DOC_TYPEREF(Cell)_REF cellp, DOC_TYPEREF(Interval_result)_REF int_result, LIST REF interval = undef);
<b>read_cell_all_i</b>(STR REF binfop,
	    DOC_TYPEREF(Cell)_REF cellp, DOC_TYPEREF(Interval_result)_REF int_result, LIST REF interval = undef);
)
<dd>
These functions are like
CODE(DOC_IDREF(read_cell)()) and CODE(DOC_IDREF(read_cell_all)()),
except that there is no VAR(timeout) and they support intervals.
<p>
If the value of VAR(interval) is greater than 0.0, then
time sorting is automatically enabled regardless of the setting of the
DOC_OPT(SORT_TIME) option, and
whenever *VAR(interval)
seconds have passed or EOF is reached,
the functions will return non-DOC_NULL with
DOC_BOTH(CODE(*VAR(cellp) == NULL), CODE(VAR(cellp) == undef))
to indicate that an interval has ended,
and the CODE(start) and CODE(end) fields of VAR(int_result)
will be filled in with the boundaries of the interval.
CODE(DOC_C(*)VAR(binfop)) is undefined at the end of an interval.
CODE(VAR(int_result)-&gt;stats) is always DOC_NULL.
When EOF is reached, the final partial interval is returned, and the
next call will return DOC_NULL.
<p>
See the section introduction above for
DOC_REF(more details, #cell-general) and
DOC_REF(return values, #cell-return).

DOC_C(
<a name="DOC_ID(read_block)"></a>
<a name="DOC_ID(read_block_all)"></a>
<dt>
<pre>
DOC_TYPEREF(Iface) *<b>coral_read_block</b>(DOC_TYPEREF(Source) *src, DOC_TYPEREF(Blk_info) **binfop,
    DOC_TYPEREF(atm_cell) **cellp, struct timeval *timeout);
DOC_TYPEREF(Iface) *<b>coral_read_block_all</b>(DOC_TYPEREF(Blk_info) **binfop,
    DOC_TYPEREF(atm_cell) **cellp, struct timeval *timeout);
</pre>
<dd>
The DOC_REF(cell reading functions, #DOC_ID(read_cell)) are usually more
convenient than these block reading functions.
<p>
After a successful read, the number of valid cells in the array pointed to by
CODE(*VAR(cellp)) is indicated by
CODE(ntohl((*VAR(binfop))-&gt;cell_count)),
the number of bytes (including padding) pointed to by
CODE(*VAR(cellp)) is indicated by
CODE(ntohl((*VAR(binfop))-&gt;blk_size)),
and the size of a cell is
CODE(DOC_REF(coral_cell_size, #DOC_TYPE(atm_cell))(VAR(iface))).
The VAR(n)th cell in the array pointed to by *VAR(cellp) which was
read from interface VAR(iface) can be found with the expression
CODE(DOC_IDREF(nth_cell)(iface, *cellp, n)).
<p>
)
</dl>

<a name="cell-other"></a>
<h4>Related Functions</h4>
<dl>

DOC_C(
<a name="DOC_ID(nth_cell)"></a>
<dt>
<pre>
DOC_TYPEREF(atm_cell) *<b>coral_nth_cell</b>(const DOC_TYPEREF(Iface) *iface,
    DOC_TYPEREF(atm_cell) *blk, int n)
</pre>
<dd>
Returns a pointer to the VAR(n)th cell in the array of cells pointed
to by VAR(blk), which was read from VAR(iface).
(CODE(DOC_IDREF(nth_cell)()) is actually defined as a macro.)
)

DOC_C(
<a name="DOC_ID(cell_block_hook)"></a>
<dt>
<pre>
void (*<b>coral_cell_block_hook</b>)(const DOC_TYPEREF(Iface) *iface, const DOC_TYPEREF(Blk_info) *binfo)
</pre>
<dd>
If CODE(coral_cell_block_hook) is not DOC_NULL,
the function to which it
points will be called whenever a cell reading function or packet reading
function reads a new block of ATM cells.
VAR(iface) and VAR(binfo) will point to data about the new block.
The default value of CODE(DOC_IDREF(cell_block_hook)) is DOC_NULL.
)

DOC_C(
<a name="DOC_ID(proto_rule)"></a>
<dt>
<pre>
int <b>coral_proto_rule</b>(const DOC_TYPEREF(Iface) *iface, uint32_t subif,
    DOC_TYPEREF(Protocol) *protop)
</pre>
<dd>
This function compares VAR(iface) and VAR(subif) (ATM vp:vc) against
the DOC_CMD_USAGE(CODE(proto), #proto)
and DOC_CMD_USAGE(CODE(deny), #deny)
configuration rules.
If they are denied by the rules, CODE(coral_proto_rule) returns 0.
Otherwise, it sets CODE(*VAR(protop)) to the
DOC_CMD_USAGE(protocol identifier, #protocols)
according to the rules, and returns&nbsp;1.
Cells that would be denied by the rules are never returned by the cell API,
but this function is still needed to find the protocol of the PDU to which
a cell belongs or to test for denial of a cell returned by the block API.
<p>
If there is no matching
DOC_CMD_USAGE(CODE(proto), #proto)
configuration rule for VAR(subif), and there is no default
protocol for VAR(iface),
the protocol for 0:0 through 0:15 defaults to
DOC_PROTO(PROTO_UNKNOWN),
the protocol for 0:16 defaults to
DOC_PROTO(DLT_ILMI),
and the protocol for all other virtual channels defaults to
DOC_PROTO(DLT_ATM_RFC1483).
<p>
Although DOC_IDREF(read_pkt) puts IEEE 802.1Q VLAN IDs
in the pkt_result-&gt;subif field, protocol rules should not be applied to
VLAN IDs.
)

<a name="DOC_ID(cell_to_pkt)"></a>
<dt>
DOC_PROTOTYPE(
int <b>coral_cell_to_pkt</b>(const DOC_TYPEREF(Iface) *iface, DOC_TYPEREF(atm_cell) *cell,
    DOC_TYPEREF(Pkt_buffer) *pkt),
<b>cell_to_pkt</b>(SCALAR iface, DOC_TYPEREF(Cell)_REF cell, DOC_TYPEREF(Pkt_buffer)_REF pkt)
)
<dd>
DOC_BOTH(
VAR(Cell) is a pointer to the first cell of an AAL5 PDU (in network
byte order).,
<var>cell</var> is a reference to a DOC_TYPEREF(Cell) object,
returned by DOC_IDREF(read_cell).
)
CODE(DOC_IDREF(cell_to_pkt)) fills in the object
DOC_BOTH(pointed to, referenced) by VAR(pkt) with
information from VAR(cell) and VAR(iface),
for use with functions that expect a
DOC_TYPEREF(Pkt_buffer) argument.
VAR(Iface) and the cell's vp:vc are used to determine the protocol of
the data according to the configuration
DOC_CMD_USAGE(CODE(proto), #proto) rules.
If VAR(iface) is DOC_NULL,
CODE(VAR(pkt)-&gt;protocol) will be set to
DOC_PROTO(PROTO_UNKNOWN).
<p>
The return value is 0 if 
VAR(iface) and the cell's vp:vc match a configuration
DOC_CMD_USAGE(CODE(deny), #deny) rule, otherwise 1.

DOC_PERL(
<a name="DOC_ID(get_ip)"></a>
<dt>
<pre>
<b>get_ip</b>(SCALAR iface, REFERENCE data)
</pre>
<dd>
This Perl-only function is another shortcut for a common action:
taking a DOC_TYPEREF(Cell) or DOC_TYPEREF(Pkt_buffer)
and extracting the IPv4-level data from it.
<var>iface</var> is the interface from which the
DOC_TYPEREF(Cell) or DOC_TYPEREF(Pkt_buffer) was read
(by DOC_IDREF(read_cell)() or
DOC_IDREF(read_pkt)()).
VAR(data) is a
reference to the
DOC_TYPEREF(Cell) or DOC_TYPEREF(Pkt_buffer) itself.
Returns the byte string
data starting with the IPv4 header, or DOC_NULL if there was any error.
(IP version != 4 counts as an error.)
The byte string can then be parsed by the
DOC_REF(Unpack, ../libsrc/CRL/doc/Unpack.html) functions.
)

</dl>


<a name="info"><h3>Information</h3></a>
These functions provide information about
CoralReef, cells, interfaces, and sources.
<dl>

DOC_C(
<a name="DOC_ID(file_version)"></a>
<dt>
<pre>
const char *<b>coral_file_version</b>(const DOC_TYPEREF(Source) *src);
</pre>
<dd>
Returns a pointer to a static buffer containing a string describing a
file format version.
If VAR(src) corresponds to a tracefile,
the string describes the file format of the tracefile;
if VAR(src) is DOC_NULL,
the string describes the current file format (i.e., the highest format version
that this version of libcoral can read, and the format that would be written by
DOC_IDREF(write)() in this version of libcoral).
)

DOC_PERL(
<dt>
<a name="DOC_ID(get_cell_timestamp)">
<pre>
<b>get_cell_timestamp</b>(DOC_TYPEREF(Cell)_REF cell);
</pre>
<dd>
Defunct.  The DOC_TYPEREF(Cell) object now has a member
called timestamp.<BR>
Old call: CODE($stamp = DOC_IDREF(get_cell_timestamp)($cell);)<BR>
New call: CODE($stamp = $cell-&gt;timestamp($iface);)<BR>
)

<a name="DOC_ID(read_clock)">
<a name="DOC_ID(read_clock_double)">
<a name="DOC_ID(read_clock_sec_nsec)">
DOC_C(
<a name="DOC_CORAL(TIMESTAMP_TO_TIMEVAL)"></a>
<a name="DOC_CORAL(TIMESTAMP_TO_TIMESPEC)"></a>
)
<dt>
DOC_PROTOTYPE(

double <b>coral_read_clock_double</b>(const DOC_TYPEREF(Iface) *iface, const DOC_TYPEREF(Timestamp) *t);
void <b>coral_read_clock_sec_nsec</b>(const DOC_TYPEREF(Iface) *iface, const DOC_TYPEREF(Timestamp) *t,
	time_t *sec, long *nsec);
void <b>DOC_CORAL(TIMESTAMP_TO_TIMEVAL)</b>(const DOC_TYPEREF(Iface) *iface, const DOC_TYPEREF(Timestamp) *t,
	struct timeval *tv);
void <b>DOC_CORAL(TIMESTAMP_TO_TIMESPEC)</b>(const DOC_TYPEREF(Iface) *iface, const DOC_TYPEREF(Timestamp) *t,
	struct timespec *ts);,
<b>DOC_ID(read_clock_sec_nsec)</b>(SCALAR iface, SCALAR t);
<b>DOC_ID(read_clock_double)</b>(SCALAR iface, SCALAR t);
)
<dd>
These functions parse the timestamp VAR(t), which belongs to a
DOC_TYPEREF(Cell) or DOC_TYPEREF(Pkt_buffer)
read from interface VAR(iface), and convert it to a more useful
format.
<p>
If the DOC_OPT(NORMALIZE_TIME)
option is set, the result will be measured from the unix epoch;
otherwise, the result will have some interface-dependant epoch.
Normalization may introduce some error in the precision; this error will be
the same for all timestamps from the same interface, but may be different
for different interfaces.
<p>
These functions automatically correct the case in which the FORE card doesn't
increment the firmware clock because it misses a hardware clock wrap,
unless the DOC_OPT(FATM_RAW_TIME)
option is set.
<p>
CODE(DOC_IDREF(read_clock_double)()) returns the time
as floating point number of seconds.
Note that some precision may be lost by the conversion to double.
<p>
DOC_BOTH(

CODE(DOC_IDREF(read_clock_sec_nsec)()),
CODE(DOC_CORAL(TIMESTAMP_TO_TIMEVAL)()), and
CODE(DOC_CORAL(TIMESTAMP_TO_TIMESPEC)())
splits the time into two integers, seconds and residual fractions of a second,
and writes them into *VAR(sec) and *VAR(nsec),
*VAR(tv), or *VAR(ts), respectively.
,

CODE(DOC_IDREF(read_clock_sec_nsec)())
returns the time as a 2-element list of seconds and nanoseconds.
)

DOC_C(
<a name="DOC_ID(cell_time_double)"></a>
<dt>
<pre>
double <b>coral_cell_time_double</b>(const DOC_TYPEREF(Iface) *iface, DOC_TYPEREF(atm_cell) *cell);
</pre>
<dd>
Equivalent to CODE(DOC_IDREF(read_clock_double)(VAR(iface), DOC_IDREF(cell_time)(VAR(iface), VAR(cell)))).
)

<a name="DOC_ID(next_interface)">
<a name="DOC_ID(next_source)">
<dt>
DOC_PROTOTYPE(
DOC_TYPEREF(Iface) *<b>coral_next_interface</b>(const DOC_TYPEREF(Iface) *iface);
DOC_TYPEREF(Source) *<b>coral_next_source</b>(const DOC_TYPEREF(Source) *src);,
<b>next_interface</b>(SCALAR iface);
<b>next_source</b>(SCALAR src);
)
<dd>
If VAR(iface)/VAR(src) is DOC_NULL,
these functions return a pointer to the first CoralReef interface/source;
otherwise, they return a pointer to the interface/source following
VAR(iface)/VAR(src).
They return DOC_NULL if there is no next interface/source.
The order in which interfaces/sources are returned
is not necessarily the order in which they were opened.
These functions are used to step through all interfaces/sources, for example:
DOC_BOTH(
<pre>
    DOC_TYPEREF(Source) *src = NULL;
    while ((src = DOC_IDREF(next_source)(src))) {
        DOC_IDREF(dump)(src);
    }
</pre>,
<pre>
    $iface = undef;
    while (($iface = DOC_IDREF(next_interface)($iface))) {
        # operate on iface 
    }
</pre>
)


<a name="DOC_ID(next_src_iface)"></a>
<dt>
DOC_PROTOTYPE(
DOC_TYPEREF(Iface) *<b>coral_next_src_iface</b>(const DOC_TYPEREF(Source) *src,
    const DOC_TYPEREF(Iface) *iface);,
<b>next_src_iface</b>(SCALAR src, SCALAR iface);,
)
<dd>
Like DOC_IDREF(next_interface)(), except it
only returns interfaces of VAR(src).


<a name="DOC_ID(source_get_filename)"></a>
<dt>
DOC_PROTOTYPE(
const char *<b>coral_source_get_filename</b>(const DOC_TYPEREF(Source) *src);,
<b>source_get_filename</b>(SCALAR src);
)
<dd>
Returns the name of the file or network interface of source VAR(src),
without a 
DOC_CMD_USAGE(coral type prefix, #sourcenames).
Returns DOC_NULL if VAR(src) is bad.

<a name="DOC_ID(source_get_name)"></a>
<dt>
DOC_PROTOTYPE(
const char *<b>coral_source_get_name</b>(const DOC_TYPEREF(Source) *src);,
<b>source_get_name</b>(SCALAR src);
)
<dd>
Returns the name of the source VAR(src),
including a
DOC_CMD_USAGE(coral type prefix, #sourcenames),
if any.
Returns DOC_NULL if VAR(src) is bad.

DOC_C(
<a name="DOC_ID(source_get_comment)"></a>
<dt>
<pre>
const char *<b>coral_source_get_comment</b>(const DOC_TYPEREF(Source) *src);
</pre>
<dd>
Returns a pointer to the comment string from the file header of source
VAR(src).
Returns DOC_NULL if VAR(src) is bad or there is no comment.
)

<a name="DOC_ID(get_source_count)"></a>
<dt>
DOC_PROTOTYPE(
int <b>coral_get_source_count</b>(void);,
<b>get_source_count</b>();
)
<dd>
Returns the number of sources.

<a name="DOC_ID(interface_get_src)"></a>
<dt>
DOC_PROTOTYPE(
DOC_TYPEREF(Source) *<b>coral_interface_get_src</b>(const DOC_TYPEREF(Iface) *iface);,
<b>interface_get_src</b>(SCALAR iface);
)
<dd>
Returns DOC_BOTH(a pointer to, the source descriptor of) the source to which
interface VAR(iface) belongs, or DOC_NULL if VAR(iface) is bad.

<a name="DOC_ID(interface_get_type)"></a>
<dt>
DOC_PROTOTYPE(
int <b>coral_interface_get_type</b>(const DOC_TYPEREF(Iface) *iface);,
<b>interface_get_type</b>(SCALAR iface);
)
<dd>
Return the <em>original</em> (hardware) type of interface VAR(iface),
or return DOC_CORAL(TYPE_NONE) if VAR(iface) is invalid or its type is unknown.

    <dl>
    <dt>DOC_CMD_USAGE(DOC_CORAL(TYPE_FATM), #fatm)
	<dd>FORE ATM adaptor device
    <dt>DOC_CMD_USAGE(DOC_CORAL(TYPE_POINT), #point)
	<dd>Apptel POINT device
    <dt>DOC_CMD_USAGE(DOC_CORAL(TYPE_DAG), #dag)
	<dd>Waikato DAG device
    <dt>DOC_CMD_USAGE(DOC_CORAL(TYPE_PCAPLIVE), #pcaplive)
	<dd>pcap interface
    </dl>

<a name="DOC_ID(source_get_type)"></a>
<dt>
DOC_PROTOTYPE(
int <b>coral_source_get_type</b>(const DOC_TYPEREF(Source) *src);,
<b>source_get_type</b>(SCALAR src);
)
<dd>
Return the type of source VAR(src),
or DOC_CORAL(TYPE_NONE) if VAR(src) is invalid or its type is unknown.
For live sources, the type will be one of the types listed in the description
of DOC_IDREF(interface_get_type)();
for file sources, the type will be one of the following:
    <dl>
    <dt>DOC_CMD_USAGE(DOC_CORAL(TYPE_FILE), #crl)
	<dd>CoralReef trace file
    <dt>DOC_CMD_USAGE(DOC_CORAL(TYPE_PCAP), #pcap)
	<dd>pcap (tcpdump) trace file
    <dt>DOC_CMD_USAGE(DOC_CORAL(TYPE_DAGFILE), #dagfile)
	<dd>dagtools trace file
    <dt>DOC_CMD_USAGE(DOC_CORAL(TYPE_TSH), #tsh)
	<dd>NLANR Time Sequenced Header trace file
    </dl>

<a name="DOC_ID(interface_get_datalink)"></a>
<dt>
DOC_PROTOTYPE(
int <b>coral_interface_get_datalink</b>(const DOC_TYPEREF(Iface) *iface);,
<b>interface_get_datalink</b>(SCALAR iface);
)
<dd>
Return the data link layer type of interface VAR(iface),
or DOC_PROTO(PROTO_UNKNOWN)
if the protocol is unknown,
or -1 if VAR(iface) is bad.
The data link layer type is one of the DOC_PROTO(DLT_*) (layer 2) constants
defined in the
DOC_CMD_USAGE(Command Usage, #protocols) document.  

<a name="DOC_ID(interface_get_physical)"></a>
<dt>
DOC_PROTOTYPE(
int <b>coral_interface_get_physical</b>(const DOC_TYPEREF(Iface) *iface);,
<b>interface_get_physical</b>(SCALAR iface);
)
<dd>
Return the physical layer type of interface VAR(iface),
or DOC_PROTO(PROTO_UNKNOWN)
if the protocol is unknown,
or -1 if VAR(iface) is bad.
The physical layer type is one of the DOC_PROTO(PHY_*) (layer 1) constants
defined in the
DOC_CMD_USAGE(Command Usage, #protocols) document.  

<a name="DOC_ID(interface_get_bandwidth)"></a>
<dt>
DOC_PROTOTYPE(
int <b>coral_interface_get_bandwidth</b>(const DOC_TYPEREF(Iface) *iface);,
<b>interface_get_bandwidth</b>(SCALAR iface);
)
<dd>
Return the bandwidth (in kilobits per second) of interface VAR(iface),
or 0 if the bandwidth is unknown,
or -1 if VAR(iface) is bad.

<a name="DOC_ID(source_get_number)"></a>
<a name="DOC_ID(interface_get_number)"></a>
<dt>
DOC_PROTOTYPE(
int <b>coral_source_get_number</b>(const DOC_TYPEREF(Source) *src);
int <b>coral_interface_get_number</b>(const DOC_TYPEREF(Iface) *iface);,
<b>source_get_number</b>(SCALAR src);
<b>interface_get_number</b>(SCALAR iface);
)
<dd>
Return a non-negative integer identifier of
source VAR(src) or interface VAR(iface), or return -1 if
VAR(src) or VAR(iface) is bad.
The identifier returned is not really useful except as a label.
To print an interface number, see
DOC_IDREF(fmt_if_subif)().

<a name="DOC_ID(interface_get_capture_tv)"></a>
<dt>
DOC_PROTOTYPE(
const struct timeval *<b>coral_interface_get_capture_tv</b>(const DOC_TYPEREF(Iface) *iface);,
<b>interface_get_capture_tv</b>(SCALAR iface);
)
<dd>
DOC_BOTH(
Returns a pointer to a structure containing the time (relative to the unix
epoch) of the start of the capture on interface VAR(iface),
or DOC_NULL if there was an error.
The structure will contain 0,0,
Returns the time (relative to the unix epoch) of the start
of the capture on interface VAR(iface) in the form
of (sec, usec), or (undef, undef) if there was an error.
It will return (0,0)
)
if the start time is unknown.
Note:  the microsecond component will always be 0 in traces in the old
DOC_CMD_USAGE(NLANR and MCI formats, #nlanr) and
DOC_CMD_USAGE(traces made with CoralReef, #crl)
versions prior to 3.2.2 (format version 9).

<a name="DOC_ID(interface_get_capturetime)"></a>
<dt>
DOC_PROTOTYPE(
time_t <b>coral_interface_get_capturetime</b>(const DOC_TYPEREF(Iface) *iface);,
<b>interface_get_capturetime</b>(SCALAR iface);
)
<dd>
Returns the integer component of the value that would be returned by
CODE(DOC_IDREF(interface_get_capture_tv)(VAR(iface))).

<a name="DOC_ID(proto_abbr)"></a>
<a name="DOC_ID(proto_desc)"></a>
<a name="DOC_ID(proto_str)"></a>
<dt>
DOC_PROTOTYPE(
const char *<b>coral_proto_abbr</b>(DOC_TYPEREF(Protocol) protocol);
const char *<b>coral_proto_desc</b>(DOC_TYPEREF(Protocol) protocol);
const char *<b>coral_proto_str</b>(DOC_TYPEREF(Protocol) protocol);,
<b>proto_abbr</b>(NUM protocol);
<b>proto_desc</b>(NUM protocol);
<b>proto_str</b>(NUM protocol);
)
<dd>
VAR(Protocol) is a CODE(DOC_CORAL(<var>prefix</var>_<var>name</var>))
constant (listed in the
DOC_CMD_USAGE(Command Usage, #protocols) document)
indentifying a communication protocol.
These functions return a pointer to a string describing protocol:
<ul>
<li>CODE(DOC_ID(proto_abbr)): a short name, or DOC_NULL;
<li>CODE(DOC_ID(proto_desc)): a long description, or DOC_NULL;
<li>CODE(DOC_ID(proto_str)): a long description, or "unknown VAR(N)".
</ul>

<a name="DOC_ID(proto_id)"></a>
<dt>
DOC_PROTOTYPE(
DOC_TYPEREF(Protocol) <b>coral_proto_id</b>(const char *name);,
<b>proto_id</b>(STR name);
)
<dd>
Returns a protocol id constant (listed in the
DOC_CMD_USAGE(Command Usage, #protocols) document)
corresponding to VAR(name), which may be a short abbreviation or a
long description as returned by
DOC_REF(CODE(coral_proto_{abbr,desc,str}()), #DOC_ID(proto_abbr)).

<a name="DOC_ID(proto_layer)"></a>
<dt>
DOC_PROTOTYPE(
int <b>coral_proto_layer</b>(DOC_TYPEREF(Protocol) protocol);,
<b>proto_layer</b>(NUM protocol);
)
<dd>
Returns the layer number of VAR(protocol).

</dl>

DOC_C(
<a name="vpvc"></a>
<h4>vpvc macros</h4>
Parameters:
<dl compact>
<dt>VAR(vpvc)	<dd>a variable containing a combined VPI and VCI.
<dt>VAR(vp)	<dd>a VPI (virtual path indicator)
<dt>VAR(vc)	<dd>a VCI (virtual channel indicator)
</dl>
<p>

Macros:
<dl>
<a name="get_vpvc_vp"></a>
<dt>CODE(<b>get_vpvc_vp</b>(VAR(vpvc)))
	<dd>returns the VPI of VAR(vpvc).
<a name="get_vpvc_vc"></a>
<dt>CODE(<b>get_vpvc_vc</b>(VAR(vpvc)))
	<dd>returns the VCI of VAR(vpvc).
<a name="set_vpvc_vp"></a>
<dt>CODE(<b>set_vpvc_vp</b>(VAR(vpvc), VAR(vp)))
	<dd>sets the VPI of VAR(vpvc).
<a name="set_vpvc_vc"></a>
<dt>CODE(<b>set_vpvc_vc</b>(VAR(vpvc), VAR(vc)))
	<dd>sets the VCI of VAR(vpvc).
<a name="vp_vc_to_vpvc"></a>
<dt>CODE(<b>vp_vc_to_vpvc</b>(VAR(vp), VAR(vc)))
	<dd>returns the combined value of VAR(vp) and VAR(vc).
</dl>
<p>
)

DOC_PERL(
<a name="DOC_ID(cell_size)">
<dt>
<pre>
<b>DOC_ID(cell_size)</b>(SCALAR iface);
</pre>
<dd>
Returns the size of the cell structure used by <var>iface</var>. 
)

<a name="DOC_ID(write)"><h3>Trace Writing</h3></a>
The writing API allows a programmer to copy data from a CoralReef source to
a CoralReef-format trace file.  The source is typically a OCx device
(for doing data capture), but may also be another trace file (useful for
encoding, or converting from another format).
<dl>

<a name="DOC_ID(write_open)"></a>
<dt>
DOC_PROTOTYPE(
DOC_TYPEREF(Writer) *<b>coral_write_open</b>(const char *name);,
<b>write_open</b>(STR name, STR comment = undef, STR encoding = undef, NUM version = 0);
)
<dd>
Open file VAR(name) for writing a trace file in CoralReef format.
If the name ends in CODE(".gz") or the
"DOC_CMD_USAGE(gzip, #gzip)" configuration option was
given, and CoralReef was compiled with libz, the file will be gzipped.
(DOC_IDREF(set_api)() must be called with the DOC_CORAL(API_WRITE) bit
to enable the "DOC_CMD_USAGE(gzip, #gzip)" configuration option.)

If the name is CODE("-"), data will be written to stdout.
Returns a DOC_BOTH(pointer to a coral writer, coral write descriptor (writer))
for success, DOC_NULL for failure.
The reccommended suffix for CoralReef trace files is ".crl", and for encoded
CoralReef trace files is ".enc.crl".
DOC_PERL(
<p>
Writes <var>comment</var> and <var>encoding</var> strings into the
file header, with encoding version set to <var>version</var>.
<var>Comment</var> and <var>encoding</var> default to
undef, <var>version</var> defaults to 0.
<var>Comment</var> may be up to 255 characters,
<var>encoding</var> may be up to 31 characters.
)
<p>
To ensure that all data from all sources are read, you must call
CODE(DOC_IDREF(stop)())
on any sources which have not reached EOF.
Then, to ensure that all data from all sources are written, you must call
CODE(DOC_IDREF(write_close)())
on the writer, before calling
CODE(DOC_IDREF(close)())
on the sources.

<a name="DOC_ID(DOC_BOTH(write_fdopen, write_fopen))"></a>
<dt>
DOC_PROTOTYPE(
DOC_TYPEREF(Writer) *<b>coral_write_fdopen</b>(int fd);,
<b>write_fopen</b>(FILEHANDLE file, STR comment = undef, STR encoding = undef, NUM version = 0);
)
<dd>
Like DOC_IDREF(write_open), except it uses
the already-open file DOC_BOTH(descriptor VAR(fd), handle VAR(file))
instead of a filename.
<p>
Mixing CoralReef operations with other operations
on DOC_BOTH(descriptor VAR(fd), handle VAR(file)) may have unpredictable
effects.
<p>

DOC_C(
<a name="DOC_ID(write_set_comment)"></a>
<a name="DOC_ID(write_set_encoding)"></a>
<dt>
<pre>
int <b>coral_write_set_comment</b>(DOC_TYPEREF(Writer) *writer, const char *comment);
int <b>coral_write_set_encoding</b>(DOC_TYPEREF(Writer) *writer, const char *encoding);
</pre>
<dd>
These functions set the comment or encoding strings that will be written
into the file header of VAR(writer).
The string parameters are null-terminated strings;
VAR(comment) may be up to 255 characters,
VAR(encoding) may be up to 31 characters.
These functions return 0 for success, -1 for failure.
)

<a name="DOC_ID(write_init_all)"></a>
<a name="DOC_ID(write_init_source)"></a>
<dt>
DOC_PROTOTYPE(
int <b>coral_write_init_all</b>(DOC_TYPEREF(Writer) *writer);
int <b>coral_write_init_source</b>(DOC_TYPEREF(Writer) *writer, DOC_TYPEREF(Source) *src);,
<b>write_init_all</b>(SCALAR writer);
<b>write_init_source</b>(SCALAR writer, SCALAR src);
)
<dd>
Prepare to write data from the indicated sources to VAR(writer).
Returns 0 for success, -1 for failure.

<a name="DOC_ID(write_init_interface)"></a>
<dt>
DOC_PROTOTYPE(
int <b>coral_write_init_interface</b>(DOC_TYPEREF(Writer) *writer, DOC_TYPEREF(Iface) *iface);,
<b>write_init_interface</b>(SCALAR writer, SCALAR iface);
)
<dd>
Prepare to write data from a single interface VAR(iface) to tracefile
VAR(writer).  Returns 0 for success, -1 for failure.

<a name="DOC_ID(write_cells)"></a>
<dt>
DOC_PROTOTYPE(
int <b>coral_write_cells</b>(DOC_TYPEREF(Writer) *writer, const DOC_TYPEREF(Iface) *iface,
    const DOC_TYPEREF(atm_cell) *cell, int count);,
<b>write_cell</b>(SCALAR writer, SCALAR iface, SCALAR cell);
)
<dd>
Write DOC_C(an array of VAR(count) cells pointed to by )VAR(cell)
to VAR(writer).
VAR(iface) indicates which interface the DOC_BOTH(cells were, cell was)
read from
(as returned by a CoralReef DOC_REF(reading function, #DOC_ID(read_cell)).
Returns 0 for success, -1 for failure.

DOC_C(
<a name="DOC_ID(write_block)"></a>
<dt>
<pre>
int <b>coral_write_block</b>(DOC_TYPEREF(Writer) *writer, const DOC_TYPEREF(Iface) *iface,
    const DOC_TYPEREF(Blk_info) *binfo, const DOC_TYPEREF(atm_cell) *blk);
</pre>
<dd>
Write a block of cells pointed to by VAR(blk)
with block info VAR(binfo) to VAR(writer).
The structure pointed to by VAR(binfo) must be in network byte order.
VAR(iface) indicates which interface the cells were read from
(as returned by a CoralReef reading function).
This function is more efficient than CODE(DOC_IDREF(write_cells)()).
Returns 0 for success, -1 for failure.
)

<a name="DOC_ID(write_close)"></a>
<dt>
DOC_PROTOTYPE(
int <b>coral_write_close</b>(DOC_TYPEREF(Writer) *writer);,
<b>write_close</b>(SCALAR writer);
)
<dd>
Close the coral trace indicated by VAR(writer).
Returns 0 for success, -1 for failure.
To ensure that all data from all sources are read, you must call
CODE(DOC_IDREF(stop)())
on any sources which have not reached EOF.
To ensure that all data from all sources are written, you must call
CODE(DOC_IDREF(write_close)())
on the writer, before calling
CODE(DOC_IDREF(close)())
on the sources.
</dl>

DOC_C(
<a name="coral_write-ex">
<h4>Trace writing example</h4></a>
<pre>
int main(int argc, char *argv[]) {
    DOC_TYPEREF(Writer) *writer;
    DOC_TYPEREF(Iface) *iface;
    DOC_TYPEREF(atm_cell) *blk;
    DOC_TYPEREF(Blk_info) *binfo;

    DOC_IDREF(set_duration)(60);
    if (DOC_IDREF(config_arguments)(argc, argv) &lt; 0)
	exit(2);
    writer = DOC_IDREF(write_open)("out.crl");
    if (!writer)
        exit(3);
    if (DOC_IDREF(write_init_all)(writer) &lt; 0)
        exit(4);
    if (DOC_IDREF(start_all)() &lt; 0)
        exit(5);

    while ((iface = DOC_IDREF(read_block_all)(&amp;binfo, &amp;blk, NULL))) {
        if (DOC_IDREF(write_block)(writer, iface, binfo, blk) &lt; 0)
            exit(6);
    }

    DOC_IDREF(stop_all)();
    DOC_IDREF(write_close)(writer);
    DOC_IDREF(close_all)();
}
</pre>
)

DOC_C(
<a name="pcap"><h3>Pcap (tcpdump) Conversion</h3></a>
These functions convert CoralReef structures to pcap structures, so they
may be used with pcap and BPF functions.  To use these functions,
the pcap header must be included:
<pre>
	#include &lt;pcap.h&gt;
</pre>

<dl>
)

DOC_C(
<a name="DOC_ID(iface_to_pcapp)"></a>
<a name="DOC_ID(iface_to_pcapp_raw)"></a>
<dt>
<pre>
pcap_t *<b>coral_iface_to_pcapp</b>(DOC_TYPEREF(Iface) *iface);
pcap_t *<b>coral_iface_to_pcapp_raw</b>(DOC_TYPEREF(Iface) *iface);
</pre>
<dd>
Returns a pointer to a pcap_t containing information copied from
*VAR(iface),
or returns DOC_NULL if there is an error.
If <b>coral_iface_to_pcapp_raw</b> is called, or <b>coral_iface_to_pcapp</b>
is called but VAR(iface) uses a data link layer protocol not supported
by pcap, the created pcap_t structure will be set to DLT_RAW (raw IP), and
DOC_IDREF(pkt_to_pcap)() calls on the pcap_t
will strip encapsulation from IP packets and discard non-IP packets.
<p>
The caller must not CODE(pcap_close()) or CODE(free()) the
resulting pcap_t; libcoral will do this automatically when VAR(iface)
is closed.
(Prior to version 3.4, it was the caller's responsibility to free the pcap_t.)
)

DOC_C(
<a name="DOC_ID(iface_to_pcap)"></a>
<dt>
<pre>
int <b>coral_iface_to_pcap</b>(const DOC_TYPEREF(Iface) *iface, pcap_t *pcap);
</pre>
<dd>
Obsolete.  See DOC_IDREF(iface_to_pcapp)().
)

DOC_C(
<a name="DOC_ID(pkt_to_pcap)"></a>
<dt>
<pre>
int <b>coral_pkt_to_pcap</b>(DOC_TYPEREF(Iface) *iface, const DOC_TYPEREF(Timestamp) *timestamp,
    const DOC_TYPEREF(Pkt_buffer) *pkt, pcap_t *pcap, struct pcap_pkthdr *hdr);
</pre>
<dd>
<dl>
Parameters:
<dt>VAR(iface) 
    <dd>A pointer to a coral interface from which VAR(pkt) was read
<dt>VAR(timestamp)
    <dd>A pointer to the timestamp of VAR(pkt)
<dt>VAR(pkt)
    <dd>A pointer to a packet that was read from VAR(iface)
<dt>VAR(pcap)
    <dd>A pointer to a pcap structure returned by
    DOC_IDREF(iface_to_pcapp)() or
    DOC_IDREF(iface_to_pcapp_raw)()
<dt>VAR(hdr)
    <dd>A pointer to a pcap_pkthdr which will be filled in by the call
</dl>
This function
fills in *VAR(hdr) with information from
*VAR(iface), *VAR(timestamp), and *VAR(pkt).
If *VAR(timestamp) is not DOC_NULL,
its value will be normalized to the unix epoch and copied to
CODE(VAR(hdr)-&gt;ts);
otherwise, CODE(VAR(hdr)-&gt;ts) will be set to zero.
(The timestamp was not normalized in versions before 3.2.2.)
<p>
The linktype of VAR(pcap) must be either CODE(DLT_RAW)
or compatible with the protocol of VAR(iface).
The former condition is true if VAR(pcap) was created by calling
DOC_IDREF(iface_to_pcapp_raw)().
The latter condition is true if VAR(pcap) was created by calling
DOC_IDREF(iface_to_pcapp)() on
VAR(iface) or another coral interface with the same protocol
as VAR(iface).
<p>
If the linktype of VAR(pcap) is compatible with the protocol of
VAR(iface), this function simply copies and converts the information
into VAR(hdr), and returns 0.
<p>
If the linktype of VAR(pcap) is CODE(DLT_RAW),
this function will strip off the encapsulation to find an IP packet.
If there is no IP packet, this function returns -1.
If there is an IP packet, this function returns the offset of that IP packet
within CODE(VAR(pkt)-&gt;buf), and fills in the rest of
VAR(hdr) with information about the IP packet, not the original packet.
<p>
This function returns -1 to indicate an error or that the packet could not
be converted to pcap form.
)

DOC_C(
<a name="DOC_ID(write_pkt_to_pcap)"></a>
<dt>
<pre>
int <b>coral_write_pkt_to_pcap</b>(DOC_TYPEREF(Iface) *iface, const DOC_TYPEREF(Timestamp) *timestamp,
    const DOC_TYPEREF(Pkt_buffer) *pkt, pcap_t *pcap, struct pcap_dumper_t *pcap_dumper);
</pre>
<dd>
This function calls DOC_IDREF(pkt_to_pcap)()
to convert the CoralReef packet VAR(pkt) to a pcap packet,
and writes it to VAR(pcap_dumper) with CODE(pcap_dump()).
)


DOC_C(
</dl>

<a name="pcap-ex">
<h4>Example</h4></a>
This example reads packets from a CoralReef interface and writes them to a
tcpdump file.
<pre>
	pcap_t *pcap;
	struct pcap_pkthdr pcap_hdr;
	int offset;

	/* ... */

	pcap = DOC_IDREF(iface_to_pcapp)(iface);
	if (!pcap)
	    /* handle error */;
	pcap_dumper = pcap_dump_open(pcap, filename);

	/* ... */

	iface = DOC_IDREF(read_pkt)(&amp;pkt_result, &amp;interval_result);
	if (!iface)
	    /* handle error */;
	offset = DOC_IDREF(pkt_to_pcap)(iface, pkt_result.timestamp,
	    pkt_result.packet, &amp;pcap_hdr);
	if (offset &lt; 0)
	    /* handle error */;
	pcap_dump(pcap_dumper, &amp;pcap_hdr, pkt_result.packet-&gt;buf + offset);
</pre>
Note: in the example above, it is possible to open a pcap dumper for coral
interface A, and then dump packets to it that were read from coral interface B.
This is ok only if interfaces A and B have the same data link type, bandwidth,
and other properties; otherwise,
DOC_IDREF(pkt_to_pcap)()
will return an error without writing the incompatible packet.
)

<a name="other"><h3>Other</h3></a>
<dl>

<a name="DOC_ID(filename)"></a>
<dt>
DOC_PROTOTYPE(
char *<b>coral_filename</b>(const char *str, char *dst, size_t len);,
<b>filename</b>(STR str, STR REF dst);
)
<dd>
Copies VAR(str) to VAR(dst),
with any leading "CODE(~name/)" replaced with the home directory of user
VAR(name), and any leading "~/" replaced with the home directory of the user
who owns the process.
DOC_C(
At most CODE(VAR(len) - 1) characters will be written into
VAR(dst).  (A typical value for VAR(len) is CODE(PATH_MAX),
defined in CODE(&lt;limits.h&gt;).)
If VAR(dst) is DOC_NULL,
DOC_IDREF(filename)()
will malloc VAR(len) bytes for it before writing to it.  It is the
caller's responsibility to free the allocated memory.
The return value is a pointer to the buffer containing the expanded filename,
or DOC_NULL if DOC_IDREF(filename)()
could not allocate the required memory.
)

DOC_C(
<a name="DOC_ID(inet_pton)"></a>
<dt>
<pre>
#include &lt;sys/types.h&gt;
#include &lt;sys/socket.h&gt;
int <b>coral_inet_pton</b>(int af, const char *src, void *dst);
</pre>
<dd>
Same as inet_pton(), for hosts that don't have inet_pton() or inet_aton().
(Note that inet_addr() is unable to distinguish between the IPv4 address
255.255.255.255 and an error.)
Converts an address string in VAR(src) to an internal form in
VAR(dst) according to the address family VAR(af).
Valid values for VAR(af) are AF_INET and AF_INET6.
)

<a name="DOC_ID(puts)"></a>
<dt>
DOC_PROTOTYPE(
int <b>coral_puts</b>(const char *str);,
<b>puts</b>(STR str);
)
<dd>
Like the standard C function CODE(puts(str)), except that it prints to the
CoralReef errfile instead of stdout,
and it is guaranteed to not modify CODE(errno).

DOC_C(
<a name="DOC_ID(printf)"></a>
<dt>
<pre>
int <b>coral_printf</b>(const char *fmt, ...);
</pre>
<dd>
Like CODE(printf(fmt, ...)),
except that it prints to the CoralReef errfile instead of stdout,
and it is guaranteed to not modify CODE(errno).
)

DOC_C(
<a name="DOC_ID(diag)"></a>
<dt>
<pre>
void <b>coral_diag</b>(level, (fmt, ...))
</pre>
<dd>
Like CODE(DOC_IDREF(printf)(fmt, ...)),
except that nothing will be printed if
CODE(VAR(level) &gt; verbosity).
Returns void.
)

DOC_C(
<a name="DOC_ID(sendblk)"></a>
<dt>
<pre>
int <b>coral_sendblk</b>(DOC_TYPEREF(Source) *src, int ndesc);
</pre>
<dd>
Incomplete.
)

<a name="DOC_ID(fprint_data)"></a>
<a name="DOC_ID(print_data)"></a>
<dt>
DOC_PROTOTYPE(
void <b>coral_fprint_data</b>(FILE *file, int indent, const u_char *data, size_t len);
void <b>coral_print_data</b>(int indent, const u_char *data, size_t len);,
<b>fprint_data</b>(FILEHANDLE file, NUM indent, SCALAR data, NUM len);
<b>print_data</b>(NUM indent, SCALAR data, NUM len);
)
<dd>
CODE(DOC_IDREF(print_data)) prints VAR(len) bytes from VAR(data)
to CODE(stdout) in a easily readable format:
16 hex values per line, with each line indented VAR(indent) spaces.
CODE(DOC_IDREF(fprint_data)) is like
CODE(DOC_IDREF(print_data)), except
it prints to VAR(file) instead of CODE(stdout).

<a name="DOC_ID(fprint_cell)"></a>
<a name="DOC_ID(print_cell)"></a>
<dt>
DOC_PROTOTYPE(
void <b>coral_fprint_cell</b>(FILE *file, int indent, const DOC_TYPEREF(Iface) *iface,
    const DOC_TYPEREF(atm_cell) *cell);
void <b>coral_print_cell</b>(int indent, const DOC_TYPEREF(Iface) *iface,
    const DOC_TYPEREF(atm_cell) *cell);,
<b>fprint_cell</b>(FILEHANDLE file, NUM indent, SCALAR iface, SCALAR cell);
<b>print_cell</b>(NUM indent, SCALAR iface, SCALAR cell);
)
<dd>
DOC_ID(print_cell)
prints VAR(cell) (which was read from VAR(iface)) to CODE(stdout)
in an easily readable format, with the timestamp in seconds, the
ATM header expanded by fields, and the payload in hex,
with each line indented VAR(indent) spaces.
This format is used by the application DOC_APP(crl_print).
CODE(DOC_IDREF(fprint_cell)) is like CODE(DOC_IDREF(print_cell)), except
it prints to VAR(file).

<a name="DOC_ID(fmprint_pkt)"></a>
<dt>
DOC_PROTOTYPE(
void <b>coral_fmprint_pkt</b>(FILE *file, DOC_TYPEREF(Iface) *iface,
    const DOC_TYPEREF(Timestamp) *timestamp, int minlayer, int maxlayer,
    DOC_TYPEREF(Pkt_buffer) *packet, DOC_TYPEREF(Pkt_buffer) *header,
    DOC_TYPEREF(Pkt_buffer) *trailer);,
<b>fmprint_pkt</b>(FILEHANDLE file, SCALAR iface, SCALAR timestamp, NUM minlayer, NUM maxlayer,
    DOC_TYPEREF(Pkt_buffer)_REF packet, DOC_TYPEREF(Pkt_buffer)_REF header, DOC_TYPEREF(Pkt_buffer)_REF trailer);
)
<dd>
CODE(DOC_ID(fmprint_pkt)) prints VAR(packet) and optionally
VAR(header) and VAR(trailer)
(which were read from VAR(iface)) to VAR(file)
in an easily readable format, with the timestamp in seconds.
Protocol layers less than VAR(minlayer) will be skipped;
layers between VAR(minlayer) and VAR(maxlayer) will be
expanded by fields in an easily readable format;
layers greater than VAR(maxlayer) or not understood by libcoral
will be printed in hex.
This format is used by the application DOC_APP(crl_print_pkt).

<a name="DOC_ID(fprint_pkt)"></a>
<dt>
DOC_PROTOTYPE(
void <b>coral_fprint_pkt</b>(FILE *file, DOC_TYPEREF(Iface) *iface,
    const DOC_TYPEREF(Timestamp) *timestamp, int maxlayer,
    DOC_TYPEREF(Pkt_buffer) *packet, DOC_TYPEREF(Pkt_buffer) *header,
    DOC_TYPEREF(Pkt_buffer) *trailer);,
<b>fprint_pkt</b>(FILEHANDLE file, SCALAR iface, SCALAR timestamp, NUM maxlayer,
    DOC_TYPEREF(Pkt_buffer)_REF packet, DOC_TYPEREF(Pkt_buffer)_REF header, DOC_TYPEREF(Pkt_buffer)_REF trailer);
)
<dd>
CODE(DOC_IDREF(fprint_pkt)(VAR(iface), VAR(timestamp),
VAR(maxlayer), VAR(packet),
VAR(header), VAR(trailer)))
is equivalent to
CODE(DOC_IDREF(fmprint_pkt)(VAR(iface), VAR(timestamp),
1, VAR(maxlayer), VAR(packet),
VAR(header), VAR(trailer))).

DOC_C(
<a name="DOC_ID(mprint_pkt)"></a>
<a name="DOC_ID(print_pkt)"></a>
<dt>
<pre>
void <b>coral_mprint_pkt</b>(DOC_TYPEREF(Iface) *iface, const DOC_TYPEREF(Timestamp) *timestamp,
    void *layerp, DOC_TYPEREF(Pkt_buffer) *packet, DOC_TYPEREF(Pkt_buffer) *header,
    DOC_TYPEREF(Pkt_buffer) *trailer);
void <b>coral_print_pkt</b>(DOC_TYPEREF(Iface) *iface, const DOC_TYPEREF(Timestamp) *timestamp,
    void *layerp, DOC_TYPEREF(Pkt_buffer) *packet, DOC_TYPEREF(Pkt_buffer) *header,
    DOC_TYPEREF(Pkt_buffer) *trailer);
</pre>
<dd>
These functions are like CODE(DOC_IDREF(fmprint_pkt)()),
except they print to CODE(stdout), and the layers are specified
differently.
For CODE(DOC_IDREF(mprint_pkt)()), VAR(layerp) is a pointer
to an array of two integers containing
VAR(minlayer) and VAR(maxlayer).
For CODE(DOC_IDREF(print_pkt)()), VAR(layerp) is a pointer
to a single integer containing VAR(maxlayer);
VAR(minlayer) defaults to 1.
The odd syntax for specifying layers makes these functions
suitable for use as a
DOC_IDREF(pkt_handler) for
DOC_IDREF(read_pkts)().
)

<a name="DOC_ID(fmt_if_subif)"></a>
<dt>
DOC_PROTOTYPE(
int <b>coral_fmt_if_subif</b>(char *buf, DOC_TYPEREF(Iface) *iface, uint32_t subif);,
<b>fmt_if_subif</b>(STR REF buf, SCALAR iface, NUM subif);
)
<dd>
CODE(DOC_ID(if_fmt_subif)) prints a formatted representation of
VAR(iface) id and VAR(subif) into VAR(buf).
DOC_C(
The size of VAR(buf) should be at least
CODE(DOC_CORAL(FMT_IF_SUBIF_LEN)).
)
If the data link type of VAR(iface) does not have subinterfaces,
the format is just the interface number
(DOC_IDREF(interface_get_number));
if it does, the format is
"VAR(if)[VAR(subif)]", where VAR(subif) is formated as by
DOC_IDREF(fmt_subif).
This function returns the length of the formatted string.

<a name="DOC_ID(fmt_subif)"></a>
<dt>
DOC_PROTOTYPE(
int <b>coral_fmt_subif</b>(char *buf, DOC_TYPEREF(Iface) *iface, uint32_t subif);,
<b>fmt_subif</b>(STR REF buf, SCALAR iface, NUM subif);
)
<dd>
CODE(coral_fmt_subif) prints a formatted representation of
VAR(subif) into VAR(buf).
DOC_C(
The size of VAR(buf) should be at least
CODE(DOC_CORAL(FMT_SUBIF_LEN)).
)
The format depends on the data link type of VAR(iface):
<ul>
<li>ATM: "VAR(vp):VAR(vc)"
<li>IEEE 802.3/Ethernet: "VAR(vlan_id)"
<li>other: ""
</ul>
This function returns the length of the formatted string.

<a name="DOC_ID(dump)"></a>
<a name="DOC_ID(dump_all)"></a>
<dt>
DOC_PROTOTYPE(
void <b>coral_dump</b>(const DOC_TYPEREF(Source) *src);
void <b>coral_dump_all</b>(void);,
<b>dump</b>(SCALAR src);
<b>dump_all</b>();
)
<dd>
Prints information about the indicated sources to the CoralReef errfile,
like the application DOC_APP(crl_info).

<a name="DOC_ID(stats)"></a>
<a name="DOC_ID(stats_all)"></a>
<dt>
DOC_PROTOTYPE(
void <b>coral_stats</b>(const DOC_TYPEREF(Source) *src);
void <b>coral_stats_all</b>(void);,
<b>stats</b>(SCALAR *src);
<b>stats_all</b>();
)
<dd>
Prints statistics about the indicated sources to the CoralReef errfile.

<a name="DOC_ID(in_cksum_add)"></a>
<a name="DOC_ID(in_cksum_result)"></a>
<dt>
DOC_PROTOTYPE(
uint32_t <b>coral_in_cksum_add</b>(uint32_t psum, const void *data, int len);
uint16_t <b>coral_in_cksum_result</b>(uint32_t psum);,
<b>in_cksum_add</b>(NUM psum, SCALAR data, NUM len);
<b>in_cksum_result</b>(NUM psum);
)
<dd>
Calculates the internet checksum of the string in VAR(data).
Usage:
<ol>
<li>initialize CODE(psum) to 0
<li>call CODE(DOC_BOTH(
    psum = DOC_IDREF(in_cksum_add)(psum, VAR(data), VAR(len)),
    $psum = DOC_IDREF(in_cksum_add)($psum, VAR(data), VAR(len))
))
for each segment of buffer,
where VAR(data) is DOC_C(a pointer to )the segment
and VAR(len) is the length of the segment
<li>call CODE(DOC_BOTH(
    DOC_IDREF(in_cksum_result)(psum),
    DOC_IDREF(in_cksum_result)($psum)
))
to get result.
</ol>
Segments must be short-aligned.
Entire message must have length less than 32768.

</dl>

DOC_BOTH(

<a name="types"><h3>Types</h3></a>
The definitions here are not necessarily complete; actual structures may
contain undocumented fields that should not be accessed by the programmer.
,

<a name="classes"><h3>Classes</h3></a>
)

<dl>

DOC_C(
<dt>ANSI/ISO C fixed width integer types
<a name="int8_t"></a>
<a name="uint8_t"></a>
<a name="int16_t"></a>
<a name="uint16_t"></a>
<a name="int32_t"></a>
<a name="uint32_t"></a>
<a name="int64_t"></a>
<a name="uint64_t"></a>
<dd>
<pre>
<b>int8_t</b>, <b>int16_t</b>, <b>int32_t</b>, <b>int64_t</b>,
<b>uint8_t</b>, <b>uint16_t</b>, <b>uint32_t</b>, <b>uint64_t</b>
</pre>
If these are not alrelady defined on your platform,
&lt;libcoral.h&gt; will define them.
<p>
)

DOC_C(
<a name="DOC_TYPE(Source)"></a>
<dt><b>DOC_TYPE(Source)</b> - Coral Source
<dd>
An opaque structure representing a source of network traffic:  either a
tracefile or a real network device.
See the DOC_REF(Introduction, #intro).
<p>
)

DOC_C(
<a name="DOC_TYPE(Iface)"></a>
<dt><b>DOC_TYPE(Iface)</b> - Coral Interface
<dd>
An opaque structure representing a single network device within a source
(since a tracefile may contain data from multiple devices).
See the DOC_REF(Introduction, #intro).
<p>
)

DOC_C(
<a name="DOC_TYPE(Writer)"></a>
<dt><b>DOC_TYPE(Writer)</b> - Coral Writer
<dd>
An opaque structure representing a file to which the
DOC_IDREF(write) functions will write.
<p>
)

DOC_C(
<a name="DOC_TYPE(Timestamp)"></a>
<dt><b>DOC_TYPE(Timestamp)</b> - Coral Timestamp
<dd>
An opaque interface-specific timestamp format that should be accessed through
the DOC_IDREF(read_clock) functions.
<p>
)

DOC_C(
<a name="DOC_TYPE(Protocol)"></a>
<dt><b>DOC_TYPE(Protocol)</b> - Coral Protocol
<dd>
A protocol identifier.  See the
DOC_CMD_USAGE(protocols, #protocols) section of the
DOC_CMD_USAGE(Command Usage) document.
<p>
)

DOC_C(
<a name="DOC_TYPE(Blk_info)"></a>
<dt><b>DOC_TYPE(Blk_info)</b> - ATM block info
<dd>
The <b>DOC_TYPE(Blk_info)</b> structure defined in CODE(&lt;libcoral.h&gt;)
is used by many functions.  All members are in network byte order.
It has at least these members:
<pre>
    u_int               interface;      /* which card this came from, if 
                                         * applicable */
    u_int               blk_size;       /* number of bytes in block */
    u_int               cell_count;     /* number of valid cells in this blk */
    u_int               cells_lost;     /* number of cells lost during block */
    u_int               unknown_vpi_vci;/* cells dropped because vpi/vci 
                                         * unknown */
    struct timespec     tbegin;         /* time of block start */
    struct timespec     tend;           /* time of block end */
</pre>
<dd>
Note that the CODE(interface) field may not correspond to
the number of the VAR(iface) pointer returned by the
CoralReef reading functions.
<p>
)

DOC_C(
<a name="atm_hdr"></a>
<dt><b>atm_hdr</b> - ATM header
<dd>
The CODE(atm_hdr.h) structure will only be available if
CODE(BYTE_ORDER) or CODE(WORDS_BIGENDIAN) is defined
when CODE(&lt;libcoral.h&gt;) is included.
(CODE(BYTE_ORDER) is defined in CODE(&lt;sys/param.h&gt;)
on some platforms,
and CODE(WORDS_BIGENDIAN) can be defined by a GNU configure script.)
The programmer must ensure that CODE(atm_hdr.ui) is in host byte order
before accessing fields of CODE(atm_hdr.h).
<pre>
union <b>atm_hdr</b> {
    struct {
        uint32_t gfc        : 4;  /* generic flow control */
        uint32_t vpvc       : 24; /* virtual path + circuit indicators */
        uint32_t oam_rm     : 1;  /* PTI: OAM/RM indicator (ie, not user data) */
        uint32_t congestion : 1;  /* PTI: we don't use this */
        uint32_t sdu_type   : 1;  /* PTI: in AAL5, this marks end of SAR-SDU */
        uint32_t clp        : 1;  /* cell loss priority */
    } h;
    uint32_t ui;
};
</pre>
)

DOC_C(
<a name="DOC_TYPE(atm_cell)"></a>
<dt><b>DOC_TYPE(atm_cell)</b> - ATM cell
<dd>
As of version 3.3, the ATM cell record structure is not directly accessible;
CODE(DOC_TYPE(atm_cell)) is just CODE(void).
All access to the fields of a cell record must be done with the
accessor functions below.  This is so libcoral can support different record
layouts used by different hardware, firmware, and drivers.
<p>
Any of the accessors that return a pointer may return DOC_NULL
if the field is not available because of hardware, firmware, or driver options.
<dl>
<a name="DOC_ID(cell_time)"></a>
<dt>CODE(
const DOC_TYPEREF(Timestamp) *<b>coral_cell_time</b>(VAR(iface), VAR(cell));
)
    <dd>Returns a pointer to the timestamp of VAR(cell), in an
    interface-specific format that should be accessed through the
    DOC_IDREF(read_clock) functions.
<a name="DOC_ID(cell_header)"></a>
<dt>CODE(
const union atm_hdr *<b>coral_cell_header</b>(VAR(iface), VAR(cell));
)
    <dd>Returns a pointer to the first 4 bytes (containing VPI, VCI, PTI, CLP)
    of the ATM header of VAR(cell) (in network byte order).  The result
    will be DOC_NULL if VAR(iface) is not an ATM interface.
<a name="DOC_ID(cell_hec)"></a>
<dt>CODE(
const char *<b>coral_cell_hec</b>(VAR(iface), VAR(cell));
)
    <dd>Returns a pointer to the Header Error Control byte of the ATM header of
    VAR(cell).
<a name="DOC_ID(cell_payload)"></a>
<dt>CODE(
const char *<b>coral_cell_payload</b>(VAR(iface), VAR(cell));
)
    <dd>Returns a pointer to the 48-byte payload of VAR(cell).
<a name="DOC_ID(cell_size)"></a>
<dt>CODE(
size_t <b>coral_cell_size</b>(VAR(iface));
)
    <dd>Returns the size of the cell structure used by VAR(iface).
</dl>
VAR(Iface) is a CODE((DOC_TYPEREF(Iface) *)) pointing to the interface
from which VAR(cell) was read.  VAR(Cell) is a
CODE((DOC_TYPE(atm_cell) *)) pointing to the cell record from which the
field will be read.  Any of the accessor functions that return a pointer may
return DOC_NULL if the corresponding field is not present in the cell
structure for the given interface.
<p>
The old version of the structure is documented here for reference only.
<pre>
typedef struct {
    DOC_TYPEREF(Timestamp) t;	/* timestamp, in card-specific format */
    union DOC_REF(atm_hdr, #atm_hdr) cu;		/* ATM header (without HEC) */
    union {
	char payload[48];
	short payload_shorts[24];
	u_int payload_i[12];
    } p;			/* ATM cell payload == SAR-PDU */
} <b>DOC_TYPE(atm_cell)</b>;
</pre>
)

DOC_PERL(
<a name="DOC_TYPE(Cell)"></a>
<dt><b>DOC_TYPE(Cell)</b>
<dd>
This class is returned by a call to one of the DOC_IDREF(read_cell) functions,
representing a cell and its members.
All member functions require the interface as an argument, eg:<BR>

<code>$header = $cell-&gt;header($iface);</code><BR>

This header (or the payload) can then be parsed with the
DOC_REF(Unpack, ../libsrc/CRL/doc/Unpack.html) functions.

<pre>
    SCALAR timestamp	# time cell was read (interpret with DOC_IDREF(read_clock) functions)
    STR header		# link layer header (eg, ATM)
    STR hec		# HEC that libcoral doesn't include in the header
    STR payload		# link or sub-network layer packet
</pre>
)

DOC_C(
<a name="aal5_trailer_t"></a>
<dt><b>aal5_trailer_t</b> - ATM AAL5 trailer
<dd>
<pre>
typedef struct {
    uint8_t	cpcs_uu;	/* CPCS user-to-user inidication */
    uint8_t	cpi;		/* common part indicator */
    uint16_t	length;		/* length of CPCS PDU payload */
    uint32_t	crc;		/* cyclic redundancy check of CPCS PDU */
} <b>aal5_trailer_t</b>;
</pre>
<p>
)

DOC_C(
<a name="DOC_TYPE(llcsnap)"></a>
<dt><b>DOC_TYPE(llcsnap)</b> - LLC/SNAP header (IEEE 802.2 and rfc1042)
<dd>
<pre>
typedef struct {
    uint8_t	llc_dsap;
    uint8_t	llc_ssap;
    uint8_t	llc_cntl;
    uint8_t	snap_org[3];
    uint16_t	snap_type;
} <b>DOC_TYPE(llcsnap)</b>;
</pre>
<p>
)

<a name="DOC_TYPE(Pkt_buffer)"></a>
<dt><b>DOC_TYPE(Pkt_buffer)</b> - Buffer structure for packet API
<dd>
DOC_BOTH(
<pre>
typedef struct {
    int caplen;			/* length of data actually captured in buf */
    int totlen;			/* total length of pkt (negative if unknown) */
    const char *buf;		/* data (aligned to a multiple of 4 bytes) */
    DOC_TYPEREF(Protocol) protocol;	/* DOC_CMD_USAGE(protocol, #protocols) */
} <b>DOC_TYPE(Pkt_buffer)</b>;
</pre>
,

<pre>
    NUM caplen		# length of data actually captured in buf
    NUM totlen		# total length of pkt (negative if unknown)
    STR buf		# data (in a byte-string format)
    NUM protocol	# protocol (ie, what kind of buffer is this?)
</pre>
)
<p>

<a name="DOC_TYPE(Pkt_stats)"></a>
<dt><b>DOC_TYPE(Pkt_stats)</b> - Statistics for packet API
<dd>
DOC_C(
<pre>
typedef struct {
)dnl
DOC_PERL(
<pre>
)dnl
    DOC_uint64 l2_recv;           DOC_COM(Layer 2 PDUs received)
    DOC_uint64 l2_drop;           DOC_COM(Layer 2 PDUs dropped)
    DOC_uint64 pkts_recv;         DOC_COM(packets received)
    DOC_uint64 pkts_drop;         DOC_COM(packets dropped)
    DOC_uint64 truncated;         DOC_COM(packets truncated by insufficient capture)
    DOC_uint64 driver_corrupt;    DOC_COM(cell looks bad from the capture device)
    DOC_uint64 too_many_vpvc;     DOC_COM(too many simultaneous vpvc pairs)
    DOC_uint64 buffer_overflow;   DOC_COM(AAL5 cell stream &gt; MAX_PACKET_SIZE)
    DOC_uint64 aal5_trailer;      DOC_COM(AAL5 trailer had bad length)
    DOC_uint64 ok_packet;
DOC_C(
} <b>DOC_TYPE(Pkt_stats)</b>;
</pre>
)dnl
DOC_PERL(
</pre>
)dnl
The CODE(l2_recv) and CODE(l2_drop) fields count layer 2 PDUs
(e.g., ATM cells), and may not be totally accurate.
On interfaces that operate on blocks (i.e., POINT, FORE ATM, and DAG),
the layer 2 PDUs reported are those belonging to every block that started
within the interval.  If there are many blocks per interval the error should
be small, but if traffic is low the error is more significant.
DOC_C(
If you require more accurate per-block data, use
DOC_IDREF(cell_block_hook).
)
<p>

<a name="DOC_TYPE(Pkt_result)"></a>
<dt><b>DOC_TYPE(Pkt_result)</b> - Packet results for packet API
<dd>
DOC_BOTH(
<pre>
typedef struct {
    const DOC_TYPEREF(Timestamp) *timestamp; /* time packet was read */
    DOC_TYPEREF(Pkt_buffer) *packet;         /* link or sub-network layer packet */
    DOC_TYPEREF(Pkt_buffer) *header;         /* link layer header (eg, ATM) */
    DOC_TYPEREF(Pkt_buffer) *trailer;        /* link layer trailer (eg, AAL5) */
    uint32_t subiface;       /* sub-interface id (ATM VPVC or VLAN ID) */
} <b>DOC_TYPE(Pkt_result)</b>;
</pre>
,

<pre>
  SCALAR timestamp	# time packet was read (interpret with DOC_IDREF(read_clock) functions)
  DOC_TYPEREF(Pkt_buffer)_REF packet	# link or sub-network layer packet
  DOC_TYPEREF(Pkt_buffer)_REF header	# link layer header (eg, ATM)
  DOC_TYPEREF(Pkt_buffer)_REF trailer	# link layer trailer (eg, AAL5)
  NUM subiface		# sub-interface id (ATM VPVC or VLAN ID)
</pre>
)
The CODE(subiface) field can be formatted with
DOC_IDREF(fmt_subif)().
<p>

<a name="DOC_TYPE(Interval_result)"></a>
<dt><b>DOC_TYPE(Interval_result)</b> - Interval results for packet API
<dd>
DOC_BOTH(
<pre>
typedef struct {
    struct timeval begin;               /* beginning of interval */
    struct timeval end;                 /* end of interval */
    DOC_TYPEREF(Pkt_stats) *stats;           /* packet statistics for interval */
} <b>DOC_TYPE(Interval_result)</b>;
</pre>
,

<pre>
  LIST begin		# beginning of interval (sec, usec)
  LIST end		# end of interval (sec, usec)
  DOC_TYPEREF(Pkt_stats)_REF stats	# statistics for interval
</pre>
)

</dl>

</body>
</html>
