/* 
 * Copyright 1999, 2000, 2001 The Regents of the University of California 
 * All Rights Reserved 
 * 
 * Permission to use, copy, modify and distribute any part of this
 * CoralReef software package for educational, research and non-profit
 * purposes, without fee, and without a written agreement is hereby
 * granted, provided that the above copyright notice, this paragraph
 * and the following paragraphs appear in all copies.
 * 
 * Those desiring to incorporate this into commercial products or use
 * for commercial purposes should contact the Technology Transfer
 * Office, University of California, San Diego, 9500 Gilman Drive, La
 * Jolla, CA 92093-0910, Ph: (858) 534-5815, FAX: (858) 534-7345.
 * 
 * IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY
 * PARTY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL
 * DAMAGES, INCLUDING LOST PROFITS, ARISING OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * THE SOFTWARE PROVIDED HEREIN IS ON AN "AS IS" BASIS, AND THE
 * UNIVERSITY OF CALIFORNIA HAS NO OBLIGATION TO PROVIDE MAINTENANCE,
 * SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS. THE UNIVERSITY
 * OF CALIFORNIA MAKES NO REPRESENTATIONS AND EXTENDS NO WARRANTIES
 * OF ANY KIND, EITHER IMPLIED OR EXPRESS, INCLUDING, BUT NOT LIMITED
 * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
 * PARTICULAR PURPOSE, OR THAT THE USE OF THE SOFTWARE WILL NOT INFRINGE
 * ANY PATENT, TRADEMARK OR OTHER RIGHTS.
 * 
 * The CoralReef software package is developed by the CoralReef
 * development team at the University of California, San Diego under
 * the Cooperative Association for Internet Data Analysis (CAIDA)
 * Program. Support for this effort is provided by the CAIDA grant
 * NCR-9711092, DARPA NGI Contract N66001-98-2-8922, DARPA NMS Grant
 * N66001-01-1-8909, and by CAIDA members.
 * 
 * Report bugs and suggestions to coral-bugs@caida.org.
 */

/*
 * libcoral_const.h - libcoral constants
 * Note: libsrc/CRL/crl_opts.h is generated from this file.
 *
 * $Id: libcoral_const.h,v 1.11.8.3 2001/11/21 01:33:51 kkeys Exp $
 */


#ifndef LIBCORAL_CONST_H
#define LIBCORAL_CONST_H

#define CORAL_MAXOPEN	16

#define SW_TYPE_NONE	0
#define SW_TYPE_NLANR	1
#define SW_TYPE_MCI	2
#define SW_TYPE_CORAL	3
#define SW_TYPE_PCAP	4
#define SW_TYPE_DAG	5

/* options */
#define CORAL_OPT_SORT_TIME	    0001
#define CORAL_OPT_PARTIAL_PKT	    0002    /* on by default */
#define CORAL_OPT_FATM_RAW_TIME	    0004
#define CORAL_OPT_POINT_RAW_TIME    0010
#define CORAL_OPT_NORMALIZE_TIME    0020
#define CORAL_OPT_NO_FILTER	    0040
#define CORAL_OPT_IP_CKSUM	    0100

#define CORAL_OPT_RAW_TIME (CORAL_OPT_POINT_RAW_TIME | CORAL_OPT_FATM_RAW_TIME)

/* API identifiers */
#define CORAL_API_NONE		000
#define CORAL_API_BLOCK		001
#define CORAL_API_CELL		002
#define CORAL_API_PKT		004
#define CORAL_API_WRITE		010

/* error codes */
#define CORAL_ERROR		(-1)
#define CORAL_ENOPROTO		(-2)
#define CORAL_ELENGTH		(-3)
#define CORAL_ESYNTAX		(-4)

#endif /* LIBCORAL_CONST_H */
