#!/usr/local/bin/perl -w

use File::Basename;
use File::Find;
use strict;

# =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
# Begin main code section
#
my @apps;
my ($app_path, $test_path);

if (@ARGV == 2) {
    $app_path = shift;
    $test_path = shift;
} else {
    usage();
}

find(\&find_executables, $app_path);
make_tree($app_path);

exit(0);

# End of main code section
#
# =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

sub usage
{
    print "\n$0 [appdir] [testdir]\n";
    exit(1);
}

sub make_tree
{
    foreach my $filename (@apps) {
	print "Making: $filename\n";
	system "mkdir -p $filename";
    }
}

sub find_executables
{
    if (-x $File::Find::name and -f $File::Find::name and
	not $File::Find::name =~ /\.pl/) {
	my $chopped = $File::Find::name;
	$chopped =~ s/$app_path\/*(.*)/$1/;
	push @apps, "$test_path/$chopped";
    }
}
