#!/usr/local/bin/perl

#
# Some global utility functions
#

sub TimeStamp
{
	# (XXX) This doesn't appear to be y2k ready...
	#
	my ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = 
 		localtime(time);

# (XXX) I thought sprintf would use 0 for padding, but it seems not to...
#	return sprintf "%4d%2d%2d%2d%2d%2d", $year, $mon, $mday, $hour,
#	 $min, $sec;

	$year = 1900 + $year;
	if ($mon < 10) { $mon = "0$mon"; }
	if ($mday < 10) { $mday = "0$mday"; }
	if ($hour < 10) { $hour = "0$hour"; }
	if ($min < 10) { $min = "0$min"; }
	if ($sec < 10) { $sec = "0$sec"; }

	return "$year$mon$mday$hour$min$sec";
}

sub RecursiveDescent
{
	my $dirName = shift;
	my $actionFuncRef = shift;
	my $oldDir = `pwd`; chomp $oldDir;

	# Start the real recursion.
	#
	_RecursiveDescent($dirName, $actionFuncRef);

	# Return to original directory.
	#
	chdir $oldDir;
}

sub _RecursiveDescent
{
	my $dirName = shift;
	my $actionFuncRef = shift;

	chdir $dirName or die "Couldn't change directory to $dirName\n";

	# Make recursive function call.
	#
	&$actionFuncRef();

	# Call RecursiveDescent on all sub-directories.
	# (this is the recursive part... :>)
	#
	my @subDirs = ListSubDirectories(".");
	if (@subDirs)
	{
		my $subDir;
		foreach $subDir (@subDirs)
		{
			_RecursiveDescent("$subDir", $actionFuncRef);
		}
	}

	chdir ".." or die "Couldn't chdir to .. !\n";;
}


sub ListSubDirectories
{
	my $dirName = shift(@_);
	my @allFiles;

	opendir THEDIR, $dirName || die "Couldn't open directory $dirName, $!\n";
#	my @foo = readdir THEDIR;
#	print "Foo: ", join ' ', @foo, "\n";
	@allFiles = grep -d, readdir THEDIR;
#	print "Foo2: ", join ' ', @allFiles, "\n";
	closedir THEDIR;

	@allFiles = grep !/^\./, @allFiles;
#	print "Foo3: ", join ' ', @allFiles, "\n";

	return @allFiles;
}

sub ListFiles
{
	my $dirName = shift;
	my @allFiles;

	opendir THEDIR, $dirName || die "Couldn't open directory $dirName, $!\n";
	@allFiles = grep -f, readdir THEDIR;
	closedir THEDIR;

# 	@allFiles = grep !/^\./, @allFiles;
	return @allFiles;
}

sub ListExecutables
{
	my $dirName = shift;
	my @executables;

	opendir THEDIR, $dirName || die "Couldn't open directory $dirname, $!\n";
	@executables = grep -x, readdir THEDIR;
	closedir THEDIR;

	@executables = grep -f, @executables;
	return @executables;
}

return 1;
